/*######################################################################################
AVR Header fr die Taster Entprellung

von Peter Dannegger

Timer0 wird fr die Entprellung genutzt

#######################################################################################*/
 /**********************************
 *                                 *
 * PJ0: Escape Taste gegen GND     *
 * PJ1: Links Taste  gegen GND     *
 * PJ2: Hoch Taste   gegen GND     *
 * PJ3: Runter Taste gegen GND     *
 * PJ4: Rechts Taste gegen GND     *
 * PJ5: Enter Taste  gegen GND     *
 *                                 *
 **********************************/

#ifndef _TASTER_H_
#define _TASTER_H_



void init_taster(void);
uint8_t get_key_press(uint8_t);
uint8_t get_key_rpt(uint8_t);
uint8_t get_key_short(uint8_t);
uint8_t get_key_long( uint8_t);



#define KEY_DDR         DDRJ
#define KEY_PORT        PORTJ
#define KEY_PIN         PINJ
#define ESC_TASTER      0
#define LEFT_TASTER     1
#define UP_TASTER       2
#define DOWN_TASTER     3
#define RIGHT_TASTER    4
#define ENTER_TASTER    5

#define ALLE_TASTER     (1<<ESC_TASTER | 1<<LEFT_TASTER | 1<<UP_TASTER | 1<<DOWN_TASTER | 1<<RIGHT_TASTER | 1<<ENTER_TASTER)
#define REPEAT_MASK     (1<<ESC_TASTER | 1<<LEFT_TASTER | 1<<UP_TASTER | 1<<DOWN_TASTER | 1<<RIGHT_TASTER | 1<<ENTER_TASTER) // Repeat-Funktion: fr alle Taster
#define REPEAT_START    50                        // after 500ms
#define REPEAT_NEXT     20                        // every 200ms
 
volatile uint8_t key_state;                                // debounced and inverted key state:
                                                  // bit = 1: key pressed
volatile uint8_t key_press;                                // key press detect
 
volatile uint8_t key_rpt;                                  // key long press and repeat



#endif
