/* Menu Funnktionen */

// interne AVR Module
#include <string.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
#include <stdint.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>       // Watchdog
#include <stdlib.h> // "itoa ...

// Projekt Ordner Module;
#define extern
#include "msr_unit01.h"
#include "buttons.h"
#include "funktionen.h"
#include "mmc_funktionen.h"
#include "ETT-Display/ett240320tp32revb.h" // ET-TFT Display Funktionen
#include "Clock/clock.h"                   // DCF - Uhr Header
#include "SD_Card/fat32.h"                 // FAT32 Funktionen
#include "SD_Card/uart_routines.h"         // UART Terminal ausgabe Funktionen
#include "update.h"                        // update header
#include "debug.h"                         // abstellbarer Debugmodus fr die Fehlersuche
#undef extern



/************************************************************
Taster Bewegung Funktion;
Parameter:
          action =left,right,up,down; tab bewegen
*************************************************************/
void taster_tab(uint8_t action)
  {
    switch(action)
	      {
		    case left:  if  (Menu.Tab==0) {return;}
			            switch(Menu.Window)
			                  {
								case    Haupt_Menu: if  (Menu.Tab==3 || Menu.Tab==12 || Menu.Tab==14 || Menu.Tab==17 || Menu.Tab==18) {return;}
								                    if  (RAM_Data.AnzTyp==0 && (Menu.Tab==6 || Menu.Tab==9)) {return;} // 9 Digi Felder
                                                    if  (RAM_Data.AnzTyp==1 && Menu.Tab==5) {return;} // 4 Digi Felder
								                    if  (RAM_Data.AnzTyp>2 && RAM_Data.AnzTyp<7 && RAM_Data.SenTyp>0 && RAM_Data.SenTyp<10 && Menu.Tab==4) {return;} // Charts
								break;
								case   Pumpen_Menu: if  (Menu.Tab== 2 || Menu.Tab== 3 || Menu.Tab==11 || Menu.Tab==19 || Menu.Tab==27 || Menu.Tab==35 || Menu.Tab==43 ||
								                         Menu.Tab==51 || Menu.Tab==59 || Menu.Tab==67 || Menu.Tab==75 || Menu.Tab==78 || Menu.Tab==80) {return;}
								break;
								case   Relais_Menu: if  (Menu.Tab==3 || Menu.Tab==6 || Menu.Tab==9 || Menu.Tab==12 || Menu.Tab==15 || Menu.Tab==17 || Menu.Tab==20 || Menu.Tab==22) {return;}
								break;
								case  Relais_Liste:
								break;
								case     Info_Menu: 
								break;
								case Kalender_Menu: if  (Menu.Tab==2 || Menu.Tab==53 || Menu.Tab==55 || Menu.Tab==58 || Menu.Tab==60) {return;}
								                    if  (Menu.Tab==4 || Menu.Tab==11 || Menu.Tab==18 || Menu.Tab==25 || Menu.Tab==32 || Menu.Tab==39 || Menu.Tab==46)
													    {tab_blink(0); Menu.Tab =2; tab_blink(1); return;}
								break;
                              }
                        tab_blink(0); Menu.Tab -=1; tab_blink(1); return;
			break;
			case right: switch(Menu.Window)
			                  {
							    case      Kal_Menu: if  (Menu.Tab==2) {return;}
								break;
								case    Haupt_Menu: if  (Menu.Tab==2 || Menu.Tab==13 || Menu.Tab==16 || Menu.Tab==17 || Menu.Tab==19) {return;}
								                    if  (RAM_Data.AnzTyp==0 && (Menu.Tab==5 || Menu.Tab==8 || Menu.Tab==11)) {return;} // 9 Digi Felder
                                                    if  (RAM_Data.AnzTyp==1 && (Menu.Tab==4 || Menu.Tab==6)) {return;} // 4 Digi Felder
													if  (RAM_Data.AnzTyp==2 && Menu.Tab==3) {return;} // 1 Digi Feld
								                    if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7 && RAM_Data.SenTyp >0 && RAM_Data.SenTyp <10 && (Menu.Tab==3 || Menu.Tab==4)) {return;} // Charts
								break;
								case   Pumpen_Menu: if  (Menu.Tab== 1 || Menu.Tab==10 || Menu.Tab==18 || Menu.Tab==26 || Menu.Tab==34 || Menu.Tab==42 || Menu.Tab==50 ||
								                         Menu.Tab==58 || Menu.Tab==66 || Menu.Tab==74 || Menu.Tab==77 || Menu.Tab==79 || Menu.Tab==82) {return;}
								break;
								case   Relais_Menu: if  (Menu.Tab==2 || Menu.Tab==5 || Menu.Tab==8 || Menu.Tab==11 || Menu.Tab==14 || Menu.Tab==16 || Menu.Tab==19 || Menu.Tab==21 || Menu.Tab==24) {return;}
								break;
								case  Relais_Liste:
								break;
								case     Info_Menu: 
								break;
								case Kalender_Menu: if  (Menu.Tab== 1 || Menu.Tab== 3 || Menu.Tab==54 || Menu.Tab==57 || Menu.Tab==59 || Menu.Tab==62) {return;}
								                    if  (Menu.Tab==10 || Menu.Tab==17 || Menu.Tab==24 || Menu.Tab==31 || Menu.Tab==38 || Menu.Tab==45 || Menu.Tab==52)
													    {tab_blink(0); Menu.Tab =3; tab_blink(1); return;}
								break;
                              }
                        tab_blink(0); Menu.Tab +=1; tab_blink(1); return;
			break;
			case    up: if  (Menu.Tab==0 || Menu.Tab==1 || Menu.Window==Kal_Menu) {return;}
			            switch(Menu.Window)
			                  {
								case    Haupt_Menu: if  (Menu.Tab==2) {return;}
								                    if  ((RAM_Data.AnzTyp<7 && (Menu.Tab==14 || Menu.Tab==15)) || Menu.Tab==17 || Menu.Tab==19) {tab_blink(0);Menu.Tab -=2;tab_blink(1);return;}
													if  (Menu.Tab==18) {tab_blink(0);Menu.Tab =17;tab_blink(1);return;}
													if  (RAM_Data.AnzTyp==1)
													    { if  (Menu.Tab>2 && Menu.Tab<7) {tab_blink(0);Menu.Tab -=2;tab_blink(1);return;}
														  if  (Menu.Tab==12 || Menu.Tab==13) {tab_blink(0);Menu.Tab -=7;tab_blink(1);return;}
                                                        }
                                                    if  (RAM_Data.AnzTyp==2)
													    { if  (Menu.Tab==3) {tab_blink(0);Menu.Tab=1;tab_blink(1);return;}
														  if  (Menu.Tab==12 || Menu.Tab==13) {tab_blink(0);Menu.Tab=3;tab_blink(1);return;}
                                                        }
												    if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7)
													    {
														  if  (RAM_Data.SenTyp <10)
														      { // Charts
															    if  (RAM_Data.SenTyp >0 && Menu.Tab==4) {tab_blink(0); Menu.Tab -=1;tab_blink(1);return;}
																if  (RAM_Data.SenTyp >0 && Menu.Tab==3) {tab_blink(0); Menu.Tab =1; tab_blink(1);return;}
																if  (Menu.Tab==12 || Menu.Tab==13)
																    { if  (RAM_Data.SenTyp >0) {tab_blink(0);Menu.Tab=4;tab_blink(1);return;}
																	  else                     {tab_blink(0);Menu.Tab=1;tab_blink(1);return;}
                                                                    }
                                                              }
                                                          else{ // Listen
														        if  (Menu.Tab==12) {tab_blink(0);Menu.Tab=0;tab_blink(1); return;}
																if  (Menu.Tab==13) {tab_blink(0);Menu.Tab=2;tab_blink(1); return;}
														      }
                                                        }
													if  (RAM_Data.AnzTyp >6)
													    { // D,A-Clock, Vid
														  if  (Menu.Tab <17) {tab_blink(0);Menu.Tab=1;tab_blink(1); return;}
                                                        }
													tab_blink(0);Menu.Tab -=3;tab_blink(1); return;
								break;
								case   Pumpen_Menu: if  (Menu.Tab==2 || Menu.Tab==79 || Menu.Tab==80) {tab_blink(0);Menu.Tab -=2;tab_blink(1); return;}
								                    if  (Menu.Tab>2 && Menu.Tab<11) {tab_blink(0);Menu.Tab=2;tab_blink(1); return;}
													if  (Menu.Tab==76) {tab_blink(0);Menu.Tab=70;tab_blink(1); return;}
													if  (Menu.Tab==77 || Menu.Tab==78 || Menu.Tab>80) {tab_blink(0);Menu.Tab -=3;tab_blink(1); return;}
													tab_blink(0);Menu.Tab -=8;tab_blink(1); return;

								break;
								case   Relais_Menu: if  (Menu.Tab==2) {return;}
								                    if  (Menu.Tab==16 || Menu.Tab==21 || Menu.Tab==22) {tab_blink(0);Menu.Tab -=2;tab_blink(1); return;}
													tab_blink(0); Menu.Tab -=3;tab_blink(1); return;
								break;
								case  Relais_Liste: 
								break;
								case     Info_Menu: 
								break;
								case Kalender_Menu: if  (Menu.Tab== 2 || Menu.Tab==3 || Menu.Tab==55 || Menu.Tab==59 || Menu.Tab==60) {tab_blink(0);Menu.Tab -=2;tab_blink(1); return;}
								                    if  ((Menu.Tab>55 && Menu.Tab<59) || Menu.Tab==61 || Menu.Tab==62) {tab_blink(0);Menu.Tab -=3;tab_blink(1); return;}
													if  (Menu.Tab>3 && Menu.Tab<11) {tab_blink(0);Menu.Tab=1;tab_blink(1); return;}
													if  (Menu.Tab==53 || Menu.Tab==54) {tab_blink(0);Menu.Tab -=51;tab_blink(1); return;}
													tab_blink(0);Menu.Tab -=7;tab_blink(1); return;
								break;
                              }
			break;
			case  down: switch(Menu.Window)
			                  {
								case    Haupt_Menu: if  (Menu.Tab==11 || Menu.Tab==12 || Menu.Tab==15) {tab_blink(0);Menu.Tab +=2;tab_blink(1); return;}
								                    if  (Menu.Tab==16 || Menu.Tab==17) {tab_blink(0);Menu.Tab +=1;tab_blink(1);return;}
                                                    if  (Menu.Tab==18 || Menu.Tab==19) {return;}
													if  (RAM_Data.AnzTyp==1)
													    { if  (Menu.Tab >1 && Menu.Tab <5) {tab_blink(0);Menu.Tab +=2;tab_blink(1);return;}
														  if  (Menu.Tab==5 || Menu.Tab==6) {tab_blink(0);Menu.Tab +=7;tab_blink(1);return;}
														}
                                                    if  (RAM_Data.AnzTyp==2)
													    { if  (Menu.Tab==1 || Menu.Tab==2) {tab_blink(0);Menu.Tab =3;tab_blink(1);return;}
														  if  (Menu.Tab==3) {tab_blink(0);Menu.Tab =12;tab_blink(1);return;}
                                                        }
                                                    if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7)
													    { if  (RAM_Data.SenTyp <10)
														      { // Charts
															    if  (Menu.Tab<3 && RAM_Data.SenTyp >0)  {tab_blink(0); Menu.Tab  =3;tab_blink(1);return;}
																if  (RAM_Data.SenTyp >0 && Menu.Tab==3) {tab_blink(0); Menu.Tab +=1;tab_blink(1);return;}
																if  (RAM_Data.SenTyp >0 && Menu.Tab==4) {tab_blink(0); Menu.Tab =12;tab_blink(1);return;}
																if  (Menu.Tab==12 || Menu.Tab==13)
																    { if  (RAM_Data.SenTyp >0) {tab_blink(0);Menu.Tab=4;tab_blink(1);return;}
																	  else                     {tab_blink(0);Menu.Tab=1;tab_blink(1);return;}
                                                                    } 
                                                              }
                                                          else{ // Listen
														        if  (Menu.Tab <3) {tab_blink(0);Menu.Tab=12;tab_blink(1); return;}
													          }															    
								                    tab_blink(0);Menu.Tab +=3;tab_blink(1); return;
								break;
								case   Pumpen_Menu: if  (Menu.Tab==0 || Menu.Tab==1) {tab_blink(0);Menu.Tab =2;tab_blink(1);return;}
								                    if  (Menu.Tab==2) {tab_blink(0);Menu.Tab =3; tab_blink(1);return;}
													if  (Menu.Tab==75 || Menu.Tab==76 || Menu.Tab==79) {tab_blink(0);Menu.Tab +=3;tab_blink(1);return;}
													if  (Menu.Tab >79) {return;}
													tab_blink(0); Menu.Tab +=2; tab_blink(1); return;
								break;
								case   Relais_Menu: if  (Menu.Tab >21) {return;}
								                    if  (Menu.Tab >12 && Menu.Tab <17) {tab_blink(0);Menu.Tab +=2;tab_blink(1);return;}
													tab_blink(0); Menu.Tab +=3; tab_blink(1); return;
								break;
								case  Relais_Liste: 
								break;
								case     Info_Menu: 
								break;
								case Kalender_Menu: if  (Menu.Tab==0 || Menu.Tab==53 || Menu.Tab==57 || Menu.Tab==58) {tab_blink(0);Menu.Tab +=2;tab_blink(1);return;}
								                    if  (Menu.Tab==1 || (Menu.Tab >3 && Menu.Tab <53)) {tab_blink(0);Menu.Tab +=7;tab_blink(1);return;}
													if  (Menu.Tab==3) {tab_blink(0);Menu.Tab =54;tab_blink(1);return;}
													if  (Menu.Tab >59) {return;}
													tab_blink(0);Menu.Tab +=3;tab_blink(1);return;
								break;
                              }
			break;
		  }
  };



/************************************************
 Funktion Blink Tab Tog
 Parameter: tempo  1 bis 10
            anzahl 1 bis 255
 ************************************************/
void tab_blink_tog(uint8_t tempo, uint8_t anzahl)
  {
    Menu.TabTimer=3;
    for (uint8_t i = anzahl +1; i>0; i--)
	    { // tab blinken lassen
		  tab_blink(1); delay_ms(tempo *20);
		  tab_blink(0); delay_ms(tempo *20);
        }
  }

/************************************************
 Funktion Blink Tab
 Parameter: blinkflag=0 tab linien lschen
            blinkflag=1 tab linien erstellen
			blinkflag=2 tab blinken lassen
 ************************************************/
void tab_blink(uint8_t blinkflag)
  { 
    uint16_t blink_clr =0;
    color_set(Hintergrund);

    switch(blinkflag) // Tab Farbe einstellen
	      {
		    case 0: blink_clr =Menu.Farbe.Grund;  break;
			case 1: blink_clr =Menu.Farbe.Text;    break;
          };

    switch(Menu.Tab) // Tab Menleiste
	      {
	  	    case  0: Rectan(  0,  0, 80, 24,2,blink_clr,0);   break; // Menleiste links
            case  1: print_Str("<",2,81,16,blink_clr,no_bg);
			         print_Str(">",2,151,16,blink_clr,no_bg); break; // Menleiste mitte
		    case  2: Rectan(159,  0,239, 24,2,blink_clr,0);   break; // Menleiste rechts
          };
	
	switch(Menu.Window)
	      { case Haupt_Menu: 
		         switch(Menu.Tab)
		               { case  3: switch(RAM_Data.AnzTyp)
				                        { case  0: Rectan(  0, 23, 80, 67,2,blink_clr,0); break; // 9 dig Anzeigefeld 1
								          case  1: Rectan(  0, 23,120, 88,2,blink_clr,0); break; // 4 dig Anzeigefeld 1
                                          case  2: Rectan(  0, 23,239,153,2,blink_clr,0); break; // 1 dig Anzeigefeld 1
									      default: Rectan(  2, 36, 23, 87,2,blink_clr,0); break; // Skala-Hoch (Chart)
                                        }
                         break;
				         case  4: switch(RAM_Data.AnzTyp)
				                        { case  0: Rectan( 79, 23,160, 67,2,blink_clr,0); break; // 9 dig Anzeigefeld 2
								          case  1: Rectan(119, 23,239, 88,2,blink_clr,0); break; // 4 dig Anzeigefeld 2
									      default: Rectan(  2, 86, 23,137,2,blink_clr,0); break; // Skala-Runter (Chart)
                                        }
                         break;
				         case  5: if  (!RAM_Data.AnzTyp) {Rectan(159, 23,239, 67,2,blink_clr,0);} // 9 dig Anzeigefeld 3
							      else                   {Rectan(  0, 87,120,152,2,blink_clr,0);} // 4 dig Anzeigefeld 3
                         break;
				         case  6: if  (!RAM_Data.AnzTyp) {Rectan(  0, 66, 80,110,2,blink_clr,0);} // 9 dig Anzeigefeld 4
							      else                   {Rectan(119, 87,239,152,2,blink_clr,0);} // 4 dig Anzeigefeld 4
                         break;
		                 case  7: Rectan( 79, 66,160,110,2,blink_clr,0);   break; // 9 dig Anzeigefeld 5
		                 case  8: Rectan(159, 66,239,110,2,blink_clr,0);   break; // 9 dig Anzeigefeld 6
		                 case  9: Rectan(  0,109, 80,153,2,blink_clr,0);   break; // 9 dig Anzeigefeld 7
		                 case 10: Rectan( 79,109,160,153,2,blink_clr,0);   break; // 9 dig Anzeigefeld 8
		                 case 11: Rectan(159,109,239,153,2,blink_clr,0);   break; // 9 dig Anzeigefeld 9
		                 case 12: Rectan(  0,152, 80,186,2,blink_clr,0);   break; // SensorTyp Btn
                         case 13: Rectan(159,152,239,186,2,blink_clr,0);   break; // SensorNum Btn
		                 case 14: Rectan(  0,185, 80,219,2,blink_clr,0);   break; // AnzeigeTyp Btn
		                 case 15: Rectan( 79,185,160,219,2,blink_clr,0);   break; // Option1 Btn
		                 case 16: Rectan(159,185,239,219,2,blink_clr,0);   break; // Option2 Btn
		                 case 17: Rectan(  0,218,239,283,2,blink_clr,0);   break; // groer Relais Btn
		                 case 18: Rectan(  0,282,120,319,2,blink_clr,0);   break; // Info Feld
		                 case 19: Rectan(119,282,239,319,2,blink_clr,0);   break; // Uhr Feld
                       }
            break;
			case Pumpen_Menu:
			     switch(Menu.Tab)
				       {
					     case 75: Rectan(  0,219, 80,253,2,blink_clr,0); break; // B-Programm Auswahl
						 case 76: Rectan( 79,219,160,253,2,blink_clr,0); break; // Cursor UP
						 case 77: Rectan(159,219,239,253,2,blink_clr,0); break; // B-Woche Auswahl
						 case 78: Rectan(  0,252, 80,285,2,blink_clr,0); break; // Cursor LEFT
						 case 79: Rectan(159,252,239,285,2,blink_clr,0); break; // Curosr RIGHT
						 case 80: Rectan(  0,284, 80,319,2,blink_clr,0); break; // Clear
						 case 81: Rectan( 79,284,160,319,2,blink_clr,0); break; // Cursor DOWN
						 case 82: Rectan(159,284,239,319,2,blink_clr,0); break; // Save
                       }
			break;
			case Relais_Menu:
		         switch(Menu.Tab)
		               {
			             case  3: Rectan(  0, 23, 80, 57,2,blink_clr,0); break; // Relais Auswahl Btn
		                 case  4: Rectan( 79, 23,160, 57,2,blink_clr,0); break; // Relais Modus Btn
		                 case  5: Rectan(159, 23,239, 57,2,blink_clr,0); break; // Relais PowerDelay Btn
		                 case  6: Rectan(  0, 56, 80,105,2,blink_clr,0); break; // SwitchFeld 1.Einschaltbedingung
		                 case  7: Rectan( 79, 56,160,105,2,blink_clr,0); break; // SwitchFeld 2. Ein...
		                 case  8: Rectan(159, 56,239,105,2,blink_clr,0); break; // SwitchFeld 3. Ein...
		                 case  9: Rectan(  0,104, 80,153,2,blink_clr,0); break; // SwitchFeld 1. Ausschaltbedingung
		                 case 10: Rectan( 79,104,160,153,2,blink_clr,0); break; // SwitchFled 2. Aus...
		                 case 11: Rectan(159,104,239,153,2,blink_clr,0); break; // SwitchFeld 3. Aus...
		                 case 12: Rectan(  0,152, 80,186,2,blink_clr,0); break; // SensorTyp Btn
                         case 13: Rectan( 79,152,160,186,2,blink_clr,0); break; // SensorNum Btn
		                 case 14: Rectan(159,152,239,186,2,blink_clr,0); break; // UND ODER  Btn
		                 case 15: Rectan(  0,185,120,219,2,blink_clr,0); break; // Aktor Label Btn
		                 case 16: Rectan(119,185,239,219,2,blink_clr,0); break; // Sensor Label Btn
		                 case 17: Rectan(  0,218, 80,252,2,blink_clr,0); break; // Minus Btn
		                 case 18: Rectan( 79,218,160,252,2,blink_clr,0); break; // Cursor UP
		                 case 19: Rectan(159,218,239,252,2,blink_clr,0); break; // < > Btn
				         case 20: Rectan(  0,251, 80,285,2,blink_clr,0); break; // Cursor LEFT
			             case 21: Rectan(159,251,239,285,2,blink_clr,0); break; // Cursor RIGHT
			             case 22: Rectan(  0,284, 80,319,2,blink_clr,0); break; // Clear Btn
			             case 23: Rectan( 79,284,160,319,2,blink_clr,0); break; // Cursor DOWN
			             case 24: Rectan(159,284,239,319,2,blink_clr,0); break; // Enter Btn
					   }
            break;
			case Relais_Liste:
			     
			break;
			case Kalender_Menu:
			     switch(Menu.Tab)
				       {
					     case 53: Rectan(  0,185, 80,219,2,blink_clr,0); break; // jedes Jahr Btn
						 case 54: Rectan(159,185,239,219,2,blink_clr,0); break; // Farb Auswahl Btn
						 case 55: Rectan(  0,218, 80,252,2,blink_clr,0); break; // Uhrzeit stellen Btn
						 case 56: Rectan( 79,218,160,252,2,blink_clr,0); break; // Cursor UP
						 case 57: Rectan(159,218,239,252,2,blink_clr,0); break; // Datum stellen Btn
 						 case 58: Rectan(  0,251, 80,285,2,blink_clr,0); break; // Cursor LEFT
						 case 59: Rectan(159,251,239,285,2,blink_clr,0); break; // Cursor RIGHT
						 case 60: Rectan(  0,284, 80,319,2,blink_clr,0); break; // Clear Btn
						 case 61: Rectan( 79,284,160,319,2,blink_clr,0); break; // Cursor DOWN
						 case 62: Rectan(159,284,239,319,2,blink_clr,0); break; // Enter Btn
                       }
            break;
			case Info_Menu:
			     switch(Menu.Tab)
				       {
					     case  2: Rectan(  0, 23, 80, 57,2,blink_clr,0); break; // Leisten Farbe Auswahl
						 case  3: Rectan( 79, 23,160, 57,2,blink_clr,0); break; // Btn Farbe Auswahl
						 case  4: Rectan(159, 23,239, 57,2,blink_clr,0); break; // Screen Farbe Auswahl
						 case  5: Rectan(  0, 56, 80, 90,2,blink_clr,0); break; // DCF_On Btn
						 case  6: Rectan( 79, 56,160, 90,2,blink_clr,0); break; // MMC_Clear Btn
						 case  7: Rectan(159, 56,239, 90,2,blink_clr,0); break; // Screen Saver Btn
                       }
            break;
          }
  }



/*********************************************
 Funktion Color set
 Parameter:
 - color 0 bis 31
 *********************************************/
void color_set(uint8_t color)
  {
   switch(color)
	 { // --- Start-Screen Farben ---
	   case Hintergrund: // case 0
	            if  (RAM_Data.Farbe.Grund==0) // Background Weiss?
                    {
	                  Menu.Farbe.Grund    =0xFFFF; // weisser Screen
	                  Menu.Farbe.Text      =0x0000; // schwarzer Text
	                  Menu.Farbe.TextRot   =Rot6  ; // dunkelroter Text
	                  Menu.Farbe.TextGruen =Gruen6; // dunkelgrner Text
	                }
                else
                    {
                      Menu.Farbe.Grund    =0x0000; // schwarzer Screen
	                  Menu.Farbe.Text      =0xFFFF; // weisser Text
	                  Menu.Farbe.TextRot   =Rot2  ; // hellroter Text
	                  Menu.Farbe.TextGruen =Gruen2; // hellgrner Text
	                }
	   break;
   	   // --- dunkle Buttons ---
	   case Rot:	 Menu.Farbe.Hell      =0xF800; // helle Color-Range Start Farbe Max (case 1:)
					 Menu.Farbe.Dunkel    =0x9800; // dunkle Color-Range End Farbe Min
					 Menu.Farbe.Sub       =0x0800; // Farbabzug (HellF-(sub_F*12))
		         	 Menu.Farbe.TextRot   =Rot2  ; // Roter Text
				     Menu.Farbe.TextGruen =Gruen6; // Grner Text
					 Menu.Farbe.Text      =0xFFFF; // Normaler Text
	   break;
	   case Gruen:	 Menu.Farbe.Hell    =0x07C0;
					 Menu.Farbe.Dunkel      =0x04D0;
					 Menu.Farbe.Sub       =0x0040;
					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
	   break;
	   case Blau:	 Menu.Farbe.Hell    =0x001F;
					 Menu.Farbe.Dunkel      =0x0014;
					 Menu.Farbe.Sub       =0x0001;
					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
	   break;
       case Gelb:    Menu.Farbe.Hell    =0xFFC0;
	   			     Menu.Farbe.Dunkel      =0x9CC0;
					 Menu.Farbe.Sub       =0x0840;
					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
	   break;
	   case Weiss:   Menu.Farbe.Hell    =0xFFFF;
	   			     Menu.Farbe.Dunkel      =0xBDF7;
					 Menu.Farbe.Sub       =0x0841;
					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
       break;
	   case Cyan:	 Menu.Farbe.Hell    =0x87FF;
	   				 Menu.Farbe.Dunkel      =0x24F3;
					 Menu.Farbe.Sub       =0x0841;
					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
	   break;
	   case Magenta: Menu.Farbe.Hell    =0xFC1F;
	   				 Menu.Farbe.Dunkel      =0x9913;
					 Menu.Farbe.Sub       =0x0841;
		             Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0xFFFF;
	   break;
	   case Braun:	 Menu.Farbe.Hell    =0xEC00;
	   				 Menu.Farbe.Dunkel      =0x8900;
					 Menu.Farbe.Sub       =0x0840;
		             Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6; 
					 Menu.Farbe.Text      =0xFFFF;
	   break;
	   // --- helle Buttons ---
	   case hRot:    Menu.Farbe.Hell    =0xFFFF;
	   				 Menu.Farbe.Dunkel      =0xFCF3;
					 Menu.Farbe.Sub       =0x0041;
 					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hGruen:  Menu.Farbe.Hell    =0xFFFF;
	   				 Menu.Farbe.Dunkel      =0x9FF3;
					 Menu.Farbe.Sub       =0x0801;
					 Menu.Farbe.TextRot   =Rot2  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hBlau:   Menu.Farbe.Hell    =0xFFFF;
	   				 Menu.Farbe.Dunkel      =0x9CFF;
					 Menu.Farbe.Sub       =0x0840;
					 Menu.Farbe.TextRot   =Rot2  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hGelb:   Menu.Farbe.Hell    =0xFFFF;
	   				 Menu.Farbe.Dunkel      =0xFFC3;
					 Menu.Farbe.Sub       =0x0001;
					 Menu.Farbe.TextRot   =Rot2  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hWeiss:  Menu.Farbe.Hell    =0xFFFF; 
	   				 Menu.Farbe.Dunkel      =0xFFDE;
					 Menu.Farbe.Sub       =0x0021;
	   				 Menu.Farbe.TextRot   =Rot2  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hCyan:	 Menu.Farbe.Hell    =0xFFFF;
	   			     Menu.Farbe.Dunkel      =0x9FFF;
					 Menu.Farbe.Sub       =0x0800;
   					 Menu.Farbe.TextRot   =Rot2  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hMagenta:Menu.Farbe.Hell    =0xFFFF;
	   				 Menu.Farbe.Dunkel      =0xFCFF;
					 Menu.Farbe.Sub       =0x0040;
   					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
	   case hBraun:  Menu.Farbe.Hell    =0xFFFF; // (case: 16)
	    			 Menu.Farbe.Dunkel      =0xFE73;
					 Menu.Farbe.Sub       =0x0021;
  					 Menu.Farbe.TextRot   =Rot6  ;
					 Menu.Farbe.TextGruen =Gruen6;
					 Menu.Farbe.Text      =0x0000;
	   break;
     }
  }



/***********************************************************
 Funktion gibt die Textfarbe fr die Text Farbauswahl zurck
 ***********************************************************/
 uint16_t txt_clr(uint8_t flag)
  {
    switch(flag)
	      {
	        case 0: return Weiss;
	        case 1: return Schwarz;
	        case 2: return Blau5;
	        case 3: return Gruen5;
          }
    return 0;
  }



/****************************************************************************
 Funktion beschriftet einen Auswahl Button
 Parameter[in]; tab   =welcher Btn (ergibt sich aus Menu.Window & Menu.Tab)
                xleft =xposition links
				ytop  =yposition oben
 ****************************************************************************/
void button_text(uint8_t tab, uint8_t xleft, uint16_t ytop)
  {
   color_set(RAM_Data.Farbe.Button);

   print_Str("<          >",1,xleft+3,ytop+19,Menu.Farbe.Text,no_bg);

   switch(tab)
         { case 12: // --- Sensor Typ Auswahl ---
		            switch(RAM_Data.SenTyp)
                          { case  0: print_Str("  Typ  ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case  1: print_Str("Periode",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
							case  2: print_Str("Zeitpkt",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
							case  3: print_Str("  pH   ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
							case  4: print_Str("  EC   ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case  5: print_Str("  `C   ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case  6: print_Str("Luftfeu",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case  7: print_Str("Bodenf.",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
							case  8: print_Str("Fllst.",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case  9: print_Str(" Licht ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case 10: print_Str("Kontakt",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                            case 11: print_Str("Relais ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
							case 12: print_Str("BewProg",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                          }
           break;
		   case 13: // --- Sensor Nr.Auswahl ---
		            switch(RAM_Data.SenTyp)
		                  { case  0: print_Str("  Num  ",2,xleft+28,ytop+21,Menu.Farbe.Text,no_bg); break;
                            case  1: // Zeitperiode
                                     switch(RAM_Data.SenNum)
                                           {
				                             case 0: print_Str("Minute ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
				                             case 1: print_Str("Stunde ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
				                             case 2: print_Str("  Tag  ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
				                             case 3: print_Str(" Woche ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
				                             case 4: print_Str(" Monat ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
				                             case 5: print_Str(" Jahr  ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg); break;
                                           }
                            break;
							case  2: // Zeitpunkt
							         if  (RAM_Data.SenNum==0) {print_Str("Uhrzeit",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg);}
								 	 else                     {print_Str(" Datum ",2, xleft+12, ytop+21, Menu.Farbe.Text, no_bg);}
						    break;
		                    default: if  (RAM_Data.SenNum <10)
							             {print_Zahl(RAM_Data.SenNum+1,1,2,xleft+36,ytop+21,Menu.Farbe.Text,no_bg);} // Sensor Nummer eine ziffer
                                     else{print_Zahl(RAM_Data.SenNum+1,2,2,xleft+32,ytop+21,Menu.Farbe.Text,no_bg);} // Sensor Nummer zwei ziffern
                            break;
                          }
           break;
           case 14: if  (Menu.Window==Haupt_Menu)
		                { // --- Anzeige Typ ---
						  switch(RAM_Data.AnzTyp)
						        { case 0: print_Str("9 Digit",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // 9 digi Felder
	                              case 1: print_Str("4 Digit",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // 4 digi Felder
	                              case 2: print_Str("1 Digit",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // 1 digital Feld
	                              case 3: print_Str("  Tag  ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Tages Chart
	                              case 4: print_Str(" Woche ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Wochen Chart
	                              case 5: print_Str(" Monat ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Monats Chart
	                              case 6: print_Str(" Jahr  ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Jahres Chart
	                              case 7: print_Str("Dig.Uhr",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Digital Clock
	                              case 8: print_Str("Ana.Uhr",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // Analog Clock
	                              case 9: print_Str(" Video ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg); break; // video(option)
						        }
                        }
                    else{ // --- UND ODER ---
					      print_Str("  &  /  ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg);
					    }
           break;
		   case 15: if  (Menu.Window==Haupt_Menu)
		                { // --- Anzeige Option1 ---
						  if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7)
						      { // Tag/Woche/Monat/Jahr Auswahl
        		                switch(RAM_Data.AnzTyp)
		                              {
		 	                            case 3: print_Str("  Tag",1,xleft+23,ytop+12,Menu.Farbe.Text,no_bg); break; 
				                        case 4: print_Str("Woche",1,xleft+23,ytop+12,Menu.Farbe.Text,no_bg); break;
				                        case 5: print_Str("Monat",1,xleft+23,ytop+12,Menu.Farbe.Text,no_bg); break;
				                        case 6: print_Str(" Jahr",1,xleft+23,ytop+12,Menu.Farbe.Text,no_bg); break;
                                      }
                                uint8_t chartnum = last_next() - RAM_Data.AnzOp1; // eingestellter tag(1/7) woche(1/5) monat(1/12) jahr(1/10)
		                        if  (chartnum <10) {print_Zahl(chartnum,1,1,xleft+29,ytop+25,Menu.Farbe.Text,no_bg);}
		                        else               {print_Zahl(chartnum,2,1,xleft+23,ytop+25,Menu.Farbe.Text,no_bg);}
		                        print_Str("/",1,xleft+35,ytop+25,Menu.Farbe.Text,no_bg);
		                        chartnum = last_next(); // von insg. tag, woche, monat, jahr
		                        if  (chartnum <10) {print_Zahl(chartnum,1,1,xleft+41,ytop+25,Menu.Farbe.Text,no_bg);}
		                        else               {print_Zahl(chartnum,2,1,xleft+41,ytop+25,Menu.Farbe.Text,no_bg);}
	                          }
					  	  else{ // Feld Farbe Auswahl
                                color_set(RAM_Data.AnzOp1 +1); // Farbe einstellen
 		                        Rectan(xleft+18,ytop+7,xleft+56,ytop+23,0, Menu.Farbe.Dunkel+(5*Menu.Farbe.Sub),1);
                              }
						}
		            else{ // --- Aktor Name ---
					      print_Str("Aktor Name",2,xleft+19,ytop+25,Menu.Farbe.Text,no_bg);
					    }
		   break;
		   case 16: if  (Menu.Window==Haupt_Menu)
		                { // --- Anzeige Option2 ---  
                          if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7)
                              { 
	                            if  (RAM_Data.SenTyp >9)
		                            { // Listen Seite ...von Seiten insg.
									  print_Str("Seite",1,xleft+21,ytop+12,Menu.Farbe.Text,no_bg);
			                          if  (RAM_Data.AnzOp2 >98)      {print_Zahl(RAM_Data.AnzOp2+1,3,1,xleft+15,ytop+25,Menu.Farbe.Text,no_bg);} // Listen Seite
			                          else{ if  (RAM_Data.AnzOp2 >8) {print_Zahl(RAM_Data.AnzOp2+1,2,1,xleft+21,ytop+25,Menu.Farbe.Text,no_bg);}
			                                else                     {print_Zahl(RAM_Data.AnzOp2+1,1,1,xleft+27,ytop+25,Menu.Farbe.Text,no_bg);}
				                          }
                                      print_Str("/",1,xleft+33,ytop+25,Menu.Farbe.Text,no_bg);
			                          if  (Menu.bit16_1 >98)      {print_Zahl(Menu.bit16_1+1,3,1,xleft+39,ytop+25,Menu.Farbe.Text,no_bg);} // Seitenanzahl
			                          else{ if  (Menu.bit16_1 >8) {print_Zahl(Menu.bit16_1+1,2,1,xleft+39,ytop+25,Menu.Farbe.Text,no_bg);}
			                                else                  {print_Zahl(Menu.bit16_1+1,1,1,xleft+39,ytop+25,Menu.Farbe.Text,no_bg);}
                                          }
			                        }
	                            else{ // Skalaauflsung fr Charts
		 	                          print_Str("Aufl|sung",1,xleft+12,ytop+12,Menu.Farbe.Text,no_bg);
                                      switch(RAM_Data.AnzOp2) // Anzeige Option2 = Auflsung 
	                                        { // 0=10 1=20 2=50 3=100 Einheiten()C, (%)Lf, (l)Fllstand
	                                          case 0: print_Str(" 10",1,xleft+29,ytop+25,Menu.Farbe.Text, no_bg); break;
		                                      case 1: print_Str(" 20",1,xleft+29,ytop+25,Menu.Farbe.Text, no_bg); break;
		                                      case 2: print_Str(" 50",1,xleft+29,ytop+25,Menu.Farbe.Text, no_bg); break;
		                                      case 3: print_Str("100",1,xleft+29,ytop+25,Menu.Farbe.Text, no_bg); break;
                                            }
		                            }
	                          }
                          else{ // Farbauswahl Btn frDigiF, Clock, Video
		                        color_set(RAM_Data.AnzOp1 +1); // Farbe einstellen
		                        Rectan(xleft+20,ytop+7,xleft+58,ytop+23,0,Menu.Farbe.Dunkel+(5*Menu.Farbe.Sub),1);
		                        print_Str("Text",1,xleft+26,ytop+19,txt_clr(RAM_Data.AnzOp2), no_bg);
                              }
                        }
                    else{ // --- Sensor Name ---
					      print_Str("Sensor Name",2,xleft+15,ytop+25,Menu.Farbe.Text,no_bg);
					    }
           break;
		   case 17: // Minus Vorzeichen Btn
		            print_Str("-",2,xleft+36,ytop+21,Menu.Farbe.Text,no_bg);
		   break;
		   case 19: // Kleiner Grer Btn
		            print_Str("< >",2,xleft+28,ytop+21,Menu.Farbe.Text,no_bg);
           break;
		   case 53: // j.Jahr Btn
		            print_Str("j. Jahr",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg);
           break;
		   case 54: // Farbauswahl Kalendertag
		            color_set(Menu.bit4_1 +1); // Farbe einstellen
		            Rectan(xleft+20,ytop+7,xleft+58,ytop+23,0,Menu.Farbe.Dunkel+(5*Menu.Farbe.Sub),1);
           break;
		   case 55: // Uhrzeit stellen
		            print_Str("Uhrzeit",2,xleft+12,ytop+25,Menu.Farbe.Text,no_bg);
           break;
		   case 57: // Datum stellen
		   break;
		   case 75: // Bew.Programm wechseln
		            print_Str(" Prog. ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg);
		   break;
		   case 77: // Bew.Woche wechseln
		            print_Str(" Woche ",2,xleft+12,ytop+21,Menu.Farbe.Text,no_bg);
           break;
         }
  }



/****************************************************************************
 Funktion schreibt aktuelle Uhrzeit/Datum im richtigem Format
 --------+---------------------+
 format 0|           20:15:00  | Uhr Btn Hauptmen
 Uhrfeld |   Fr, der 09.11.13  |
 --------+---------------------+
 format 1|      20:15:00   DCF | Digital Uhr Hauptmen
 groe   |      November   Uhr |
 Digital |      Feiertag       |
 Uhr     |      Freitag        |
         |     09.11.2013      |
 --------+---------------------+
 format 2| 20:15Uhr 09.11.2013 | Uhr/Datum Kalender Men
 --------+---------------------+
 ****************************************************************************/
void display_time(uint8_t format)
  {
   	uint8_t font;
	uint8_t x_pos;
	uint8_t f_breite;
	uint16_t y_pos;
	uint16_t foo_clr;
	uint16_t text_clr;
    uint16_t red_clr;
	uint16_t back_clr;

    switch(format)
	      {
		    case 0: // kleines Datum/Zeit Feld
			        font =2; f_breite = 8; x_pos =171; y_pos =297;
			        color_set(RAM_Data.Farbe.Leiste);
			        text_clr =Menu.Farbe.Text;
				    red_clr  =Menu.Farbe.TextRot;
                    back_clr =Menu.Farbe.Dunkel +(5 * Menu.Farbe.Sub);
					if  (Menu.Clocked) {foo_clr =text_clr;} else{foo_clr =red_clr;}
					if  (RAM_Data.DCF_On)
					    { print_Str("DCF", 1, 125, 297, foo_clr, back_clr);} // Uhr luft ber DCF-Funk Signal
                    else{ print_Str("RTC", 1, 125, 297, foo_clr, back_clr);} // Uhr luft ber RealTimeClock
		     break;
			 case 1:  // Digital Uhr
			         font =4; f_breite =24; x_pos = 15; y_pos = 85;
					 text_clr =txt_clr(RAM_Data.AnzOp2);
					 color_set(RAM_Data.AnzOp1+1);
					 red_clr  =Menu.Farbe.TextRot;
				 	 back_clr =Menu.Farbe.Dunkel+(5*Menu.Farbe.Sub);
				     if  (Menu.Clocked) {foo_clr =text_clr;} else{foo_clr =red_clr;}
					 if  (RAM_Data.DCF_On)
					     { print_Str("DCF", 1, 215, 67, foo_clr, back_clr);} // Uhr luft ber DCF-Funk Signal
                     else{ print_Str("RTC", 1, 215, 67, foo_clr, back_clr);} // Uhr luft ber RealTimeClock
			 break; 
			 case 2: // Kalender Men
                     font =2; f_breite = 8; x_pos = 12; y_pos =232;
			         color_set(RAM_Data.Farbe.Grund);
					 text_clr =Menu.Farbe.Text;
					 back_clr =Menu.Farbe.Grund;
		     break;
           }

	// Uhrzeit
    print_Zahl(hh ,    2, font, x_pos             , y_pos, text_clr, back_clr); // Stunden
    print_Str (":",       font, x_pos +f_breite *2, y_pos, text_clr, back_clr); // :
    print_Zahl(mm ,    2, font, x_pos +f_breite *3, y_pos, text_clr, back_clr); // Minuten
    print_Str (":",       font, x_pos +f_breite *5, y_pos, text_clr, back_clr); // :
    print_Zahl(ss ,    2, font, x_pos +f_breite *6, y_pos, text_clr, back_clr); // Sekunden
    
    if  (Menu.Clocked)
	    {
	      switch(format)
	            {
		          case 0: // Uhr Btn
		                  if  (update.small_clock)
					          { // Datum im Uhr Btn aktualisieren
					            y_pos =313;
					            tag_zu_text(dow);
					            lcd_Ascii(dataString[0],1,125,y_pos, text_clr,back_clr);
	                            lcd_Ascii(dataString[1],1,131,y_pos, text_clr,back_clr);
	                            print_Str (", der",     1,137,y_pos, text_clr,back_clr);
								update.small_clock =0;
                              }
		          break;
			      case 1: // Digital Uhr
				          if  (update.big_clock)
				              { // groe Uhr nicht gestellt...
					            print_Zahl(day,    2,3, 12, 184, text_clr, back_clr); // Tag
   		                        print_Str (".",      3, 56, 184, text_clr, back_clr); // .
   		                        print_Zahl(mon,    2,3, 78, 184, text_clr, back_clr); // Monat
 	                            print_Str (".20",    3,122, 184, text_clr, back_clr); // .
   		                        print_Zahl(year,   2,3,188, 184, text_clr, back_clr); // Jahr
                       			
								// Monat in Schrift			        
						        uint16_t chars = monat_zu_text(mon);
						        x_pos = 120 - chars *4;
                                print_Str("         ", 2, 84, 98, text_clr, back_clr); // lschen
                                for (uint8_t i =0; i < chars; i++) {lcd_Ascii(dataString[i],2,x_pos +(i * 8), 98, text_clr, back_clr);} // Monat
                          
						        // Feiertag oder anderer besonderer Tag
				                print_Str("                   ", 2, 40, 115, text_clr, back_clr); // lschen
				                chars = feiertag(day,mon,year);
				                if  (chars)
				                    {
					                  x_pos = 120 - chars * 4;
					                  for (uint8_t i =0; i<chars; i++) {lcd_Ascii(dataString[i],2,x_pos +(i *8), 115, red_clr, back_clr);}
					                }

                                // Tag in Schrift
				                chars = tag_zu_text(dow);
					            if  (dow==7) {foo_clr =red_clr;} else{foo_clr =text_clr;}
                                x_pos = 120 - (chars *11);
				                print_Str("          ", 3, 10, 150, text_clr, back_clr); // lschen
                      	        for (uint8_t i =0; i <chars; i++) {lcd_Ascii(dataString[i],3,x_pos +(i * 22), 150, foo_clr, back_clr);}
						        update.big_clock =0;
                              }
		          break;
			      case 2: x_pos = 173; // Uhrzeit/ Datum im Kalender Men
			      break;
                }

          // Datum (01.01.24)
	      if  (format==0 || format==2)
   		      { // 
		        print_Zahl(day,     2,font, x_pos,            y_pos, text_clr, back_clr); // Tag
   		        print_Str (".",       font, x_pos+f_breite*2, y_pos, text_clr, back_clr); // .
   		        print_Zahl(mon,     2,font, x_pos+f_breite*3, y_pos, text_clr, back_clr); // Monat
 	            print_Str (".",       font, x_pos+f_breite*5, y_pos, text_clr, back_clr); // .
   		        print_Zahl(year%100,2,font, x_pos+f_breite*6, y_pos, text_clr, back_clr); // Jahr
              }
        }
  }



/***********************************************************************************************
 Funktion Label oder Value laden, speichern, ausgeben oder rcksetzen
 Parameter[in]:
 - flag: 0=Label aus EEPROM ausgeben
         1=Label aus Puffer "Ascii[]" ausgeben
		 2=Label aus Puffer in den EEPROM schreiben
		 3=Label aus EEPROM in den Puffer laden
		 4=Label im EEPROM reseten
		 5=Value aus Puffer "Ascii[]" ausgeben inkl. &/<>- (SwitchFeld)
		 6=Value aus Puffer "Value[]" ausgeben (aktuelle Messdaten)
		 7=Value aus EEPROM "Aktor[]" ausgeben inkl. &/<>- (eingabe_fld) im RelaisMen 
		 8=Value aus MinWert "Menu.bit16_1" ausgeben
		 9=Value aus MaxWert "Menu.bit16_2" ausgeben
					  
 - typ:  Typ des Label/ Value
		 1=Zeitperiode ( 6) /ohne label
		 2=Zeitpunkt   ( 2) /ohne Label
		 3=pH          ( 2) 
		 4=EC          ( 2)
		 5=Celsius    ( 4)
		 6=rel.LuftF   ( 4)
		 7=Bodenfeuchte( 8)
		 8=Flstand    ( 4)
		 9=Lux/Lumen   ( 2)
	    10=Kontakte    ( 8)
	    11=Relais      (16)
	    12=Dos.Programm( 4)
	    13=Dos.Pumpen  ( 9) 0=Magn.Ventil(Wasser Zulauf) 1-8=Dosierpumpen label
	    14=Magn.Ventile( 4) Abgnge fr Mischwasser
   num:    Nummer des Label/Value 0-15
   font:   Textfont
   xleft:  x Position
   ytop:   y Position
   fg_clr: Font Color
   bg_clr: BackGround Color
 ***********************************************************************************************/
void label_value(uint8_t flag,uint8_t typ,uint8_t num,uint8_t font,uint8_t xleft,uint16_t ytop,uint16_t txt_color,uint16_t gnd_color)
  {
	uint16_t red_color, foo_color;
	if  (txt_color==0) {red_color =Rot6;} else {red_color =Rot2;}
    
	uint8_t array_num = array_zu_sentyp(2,typ,num);
    int16_t val;
	uint8_t aktor_num = typ;
	uint8_t switch_field = num;
    
	uint8_t aor, neg, grk, font_width;
	if  (flag <2 || flag >4)
	    { 
		  switch(font)
	            {
                  case 1: font_width = 6; break;
			      case 2: font_width = 8; break;
			      case 3: font_width =22; break;
			      case 4: font_width =24; break;
                }
        }

	if  (flag <5)
	    { // --- Label ---
		  if  (typ >2)
	          { switch(flag)
		              { case 0: // --- Label aus EEPROM ausgeben ---
					    	    for (int8_t i=0; i<9; i++)
			                        { 
									  lcd_Ascii(RAM_Data.Label[array_num].Ascii[i],font,xleft+=font_width,ytop,txt_color,gnd_color);
									}
				        break;
				        case 1: // --- Label aus Puffer ausgeben ---
		                        for (int8_t i=0; i<9; i++)
		                            {
									  if  (Menu.Cursor && Menu.Cursor-1 ==i) {foo_color =red_color;} else{foo_color =txt_color;}
			                          lcd_Ascii(Menu.Ascii[i], font, xleft+=font_width, ytop, foo_color, gnd_color);
									}
                        break;
				        case 2: // --- Label aus Puffer in den EEPROM schreiben ---
				  	            for (int8_t i=0; i<9; i++) {RAM_Data.Label[array_num].Ascii[i] = Menu.Ascii[i];}
				        break;
				        case 3: // --- Label aus EEPROM in den Puffer laden ---
				                for (int8_t i=0; i<9; i++) {Menu.Ascii[i] = RAM_Data.Label[array_num].Ascii[i];}
				        break;
				        case 4: // --- Label reseten ---
				               for (uint8_t i =0; i<9; i++) {Menu.Ascii[i] =0x20;} //

				               switch(typ)
						             { case  3: // --- PH ---
								                Menu.Ascii[0] =0x70; // p
					                            Menu.Ascii[1] =0x48; // H
                                                Menu.Ascii[3] =num+0x30; // Nr.
								       break;
								       case  4: // --- EC ---
								                Menu.Ascii[0] =0x45; // E
					                            Menu.Ascii[1] =0x43; // C
                                                Menu.Ascii[3] =num+0x30; // Nr.
								       break;
								       case  5: // --- SHT C ---
								                Menu.Ascii[0] =0x43; // C
                                                Menu.Ascii[1] =0x65; // e
			                                    Menu.Ascii[2] =0x6c; // l
			                                    Menu.Ascii[3] =0x73; // s
			                                    Menu.Ascii[4] =0x69; // i
				  	                            Menu.Ascii[5] =0x75; // u
			                                    Menu.Ascii[6] =0x73; // s
			                                    Menu.Ascii[8] =num+0x30; // Nr.
								       break;
								       case  6: // --- SHT rLF ---
								                Menu.Ascii[0] =0x4c; // L
					                            Menu.Ascii[1] =0x75; // u
						                        Menu.Ascii[2] =0x66; // f
                                                Menu.Ascii[3] =0x74; // t
			                                    Menu.Ascii[4] =0x66; // f
			                                    Menu.Ascii[5] =0x65; // e
			                                    Menu.Ascii[6] =0x75; // u
                                                Menu.Ascii[7] =0x2e; // .
					                            Menu.Ascii[8] =num+0x30; // Nr.
								       break;
								       case  7: // --- Bodenfeuchte ---
								                Menu.Ascii[0] =0x42; // B
							                    Menu.Ascii[1] =0x6f; // o
                                                Menu.Ascii[2] =0x64; // d
			                                    Menu.Ascii[3] =0x65; // e
			                                    Menu.Ascii[4] =0x6e; // n
			                                    Menu.Ascii[5] =0x66; // f
					                            Menu.Ascii[6] =0x65; // e
		                                        Menu.Ascii[7] =0x2e; // .
					                            Menu.Ascii[8] =num+0x30; // Nr.
                                       break;
								       case  8: // --- Fllstand ---
								                Menu.Ascii[0] =0x46; // F
					                            Menu.Ascii[1] =0x7d; // 
						                        Menu.Ascii[2] =0x6c; // l
                                                Menu.Ascii[3] =0x6c; // l
			                                    Menu.Ascii[4] =0x73; // s
			                                    Menu.Ascii[5] =0x74; // t
			                                    Menu.Ascii[6] =0x61; // a
			                                    Menu.Ascii[7] =0x2e; // .
					                            Menu.Ascii[8] =num+0x30; // Nr.
                                       break;
								       case  9: // --- Licht ---
								                Menu.Ascii[0]=0x4c; // L
			                                    Menu.Ascii[1]=0x75; // u
					                            Menu.Ascii[2]=0x78; // x
			                                    Menu.Ascii[4] =num+0x30; // Nr.
                                       break;
								       case 10: // --- Kontakte ---
								                Menu.Ascii[0]=0x4b; // K
                                                Menu.Ascii[1]=0x6f; // o
			                                    Menu.Ascii[2]=0x6e; // n
			                                    Menu.Ascii[3]=0x74; // t
			                                    Menu.Ascii[4]=0x61; // a
					                            Menu.Ascii[5]=0x6b; // k
			                                    Menu.Ascii[6]=0x74; // t
			                                    Menu.Ascii[8]=num+0x30; // Nr.
								       break;
								       case 11: // --- Relais ---
								                Menu.Ascii[0] =0x52; // R
                                                Menu.Ascii[1] =0x65; // e
		                                        Menu.Ascii[2] =0x6c; // l
		                                        Menu.Ascii[3] =0x61; // a
		                                        Menu.Ascii[4] =0x69; // i
		                                        Menu.Ascii[5] =0x73; // s
		                                        Menu.Ascii[6] =0x20; //
		                                        if  (num <10) {Menu.Ascii[8]=num+0x30;} // 1 Ziffer
		                                        else          {Menu.Ascii[8]=num%10+0x30; Menu.Ascii[7]=num/10+0x30;} // 2 Ziffern
								       break;
								       case 12: // --- Bewsserungs Programm ---
								                Menu.Ascii[0] =0x50; // P
                                                Menu.Ascii[1] =0x72; // r
		                                        Menu.Ascii[2] =0x6f; // o
		                                        Menu.Ascii[3] =0x67; // g
		                                        Menu.Ascii[4] =0x72; // r
		                                        Menu.Ascii[5] =0x61; // a
		                                        Menu.Ascii[6] =0x6d; // m
                                                Menu.Ascii[7]= 0x6d; // m
									            Menu.Ascii[8]= num+0x30; // Nr. 1-4
								       break;
								       case 13: // --- Dosier Pumpe ---
								                Menu.Ascii[0] =0x4d; // M
                                                Menu.Ascii[1] =0x61; // a
		                                        Menu.Ascii[2] =0x67; // g
		                                        Menu.Ascii[3] =0x6e; // n
		                                        Menu.Ascii[4] =0x2e; // .
		                                        Menu.Ascii[5] =0x56; // V
		                                        Menu.Ascii[6] =0x28; // (  
									            Menu.Ascii[7] =0x6c; // l
									            Menu.Ascii[8] =0x29; // )
								       break;
                                     }
                               for (int8_t i=0; i<9; i++) {RAM_Data.Label[array_num].Ascii[i] = Menu.Ascii[i];}
				        break;
                      }
              }
        } // if  (flag <5) ENDE
    else{ // --- Value ---
	      switch(flag)
		        {
				  case 5: // Value aus Eingabe-Puffer "Ascii[]" inkl. Men Einstellung fr &/ <> - ausgeben
				          // wird fr das eingabe_fld im relais_men gebraucht
						  aor = Menu.bit2_2; // And Or
						  neg = Menu.bit1_3; // negativ
		                  grk = Menu.bit2_3; // grer kleiner 
                  break;
				  case 7: // Value aus RAM_Data.Aktor[Menu.bit6_1].Schaltbedingung[Menu.Tab -6] ausgeben, inkl. Schaltbedingungen
				          // wird fr Schalt-Felder gebraucht.
				          // Aktoren; 0-15=Relais, 16-19=B-Programme, 20-23=Alarmmeldungen
						  typ = RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].SenTyp;
                          num = RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].SenNum;
						  aor = RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].Aor;
						  neg = RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].Neg;
						  grk = RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].Grk;
						  for (uint8_t i=0; i<4; i++)
						      {Menu.Ascii[i] =RAM_Data.Aktor[aktor_num].Schaltbedingung[switch_field].Value[i];}
				  break;
				  default: switch(flag)
				                 { case 6: val =Menu.Value[array_num]; break; // Value aus MessDaten array "Value[]" ausgeben, wird fr die Digital Felder im Hauptmen gebraucht, ohne schaltbedingung
								   case 8: val =Menu.bit16_1; break; // Value aus MinWert fr Chart, ohne schaltbed.
								   case 9: val =Menu.bit16_2; break; // Value aus MaxWert fr chart, ohne schaltbed.
                                 }
                           if  (val <0)
						       { // Minus
							     neg =1;
                                 val = val + (2 * val);
                               }
                           Menu.Ascii[4] =val % 10; val = val /10;
						   Menu.Ascii[3] =val % 10; val = val /10;
						   Menu.Ascii[2] =val % 10; val = val /10;
						   Menu.Ascii[1] =val % 10; val = val /10;
						   Menu.Ascii[0] =val % 10; val = val /10;							    
				  break;
                }
          
		  // --- Value ausgeben ---
		  if  (flag==5 || flag ==7)
		      { // Einstellung &/ <> ausgeben (nur im Eingabe_fld und im SwitchFeld)
                if  (flag==5 || (flag==6 && switch_field !=0 && switch_field !=3))
				    { // UND ODER, nicht im Feld 0 oder 3 anzeigen
					  if  (aor) {print_Str("/",2,xleft+=8,ytop+3,txt_color,gnd_color);}
					  else      {print_Str("&",2,xleft+=8,ytop+3,txt_color,gnd_color);}
				    }
		        if  (grk) // <> 
				    { if  (grk==1) {print_Str(">",1,xleft+=8,ytop,txt_color,gnd_color);}
                      else         {print_Str("<",1,xleft+=8,ytop,txt_color,gnd_color);}
                    }
              }
		  // Minus Vorzeichen nur fr Celsius
          if  (typ==5 && neg)
			  { print_Str("-",font,xleft +=font_width,ytop,txt_color,gnd_color);}

		  // Formate 00:00 und 00,00 und 00.00 und 00 00
		  if  ((typ==1 && num !=0 && num !=3) || (typ >1 && typ <9))
		      {
		        for (uint8_t i=0; i<4; i++)
		            { 
		              if  (Menu.Cursor && Menu.Cursor -1 ==i)
		                  { foo_color = red_color;} // Ziffer ausgewhlt (rot) ausgeben
                      else{ foo_color = txt_color;} // Ziffer ausgeben (schwarz/weiss)

	                  lcd_Ascii(Menu.Ascii[i] +0x30,font,xleft+=font_width,ytop,foo_color,gnd_color);
	  
		              if  (i==1) // nach der 2.Ziffer ...
     	                  { 
						    if  (typ==2 && num==0)
					            { print_Str(":",1,xleft+=font_width,ytop,txt_color,gnd_color);} // doppelpunkt
                            else{ if  ((typ==1 && num==5) || (typ==2 && num==1))
					                  { print_Str(".",1,xleft+=font_width,ytop,txt_color,gnd_color);} // punkt
                                  else{ if  (typ==1 && num==4)
								            { print_Str(" ",1,xleft+=font_width,ytop,txt_color,gnd_color);} // leerzeichen
										else{ print_Str(",",1,xleft+=font_width,ytop,txt_color,gnd_color);} // komma
                                      }
                                }
                          }
                    }
              }
          else{ if  (typ==1 && num==3)
		            { // Format Mo 00Uhr  bis  So 23Uhr
                      if  (Menu.Cursor==1) {foo_color =red_color;} else{foo_color =txt_color;}
				      tag_zu_text(Menu.Ascii[0]); // Tag als Schrift in dataString[] erzeugen
				      lcd_Ascii(dataString[0],1,xleft+=font_width,ytop,foo_color,gnd_color);  // Mo
                      lcd_Ascii(dataString[1],1,xleft+=font_width,ytop,foo_color,gnd_color);  // o
					  xleft +=font_width;
					  if  (Menu.Cursor==2) {foo_color =red_color;} else{foo_color =txt_color;}
                      lcd_Ascii(Menu.Ascii[1],1,xleft+=font_width,ytop,foo_color,gnd_color);  // 0
					  if  (Menu.Cursor==3) {foo_color =red_color;} else{foo_color =txt_color;}
					  lcd_Ascii(Menu.Ascii[2],1,xleft+=font_width,ytop,foo_color,gnd_color);  // 0
                 	 }
                 else{ if  (typ==9)
			               { // Format 00000 fr Luxwerte bis ca 32000+
					              for (uint8_t i=0; i<5; i++)
				                      { 
					                    if  (Menu.Cursor && Menu.Cursor -1 ==i)
					                        { foo_color = red_color;} // Ziffer ausgewhlt (rot) ausgeben
                                        else{ foo_color = txt_color;} // Ziffer ausgeben (schwarz/weiss)
				                        lcd_Ascii(Menu.Ascii[i] +0x30,font,xleft+font_width,ytop,foo_color,no_bg);
					                  }
                                }
                            else{ if  (Menu.Cursor==1)
					                  { foo_color = red_color;} // Ziffer ausgewhlt (rot) ausgeben
                                  else{ foo_color = txt_color;} // Ziffer ausgeben (schwarz/weiss)
 
					    	      if  (typ==10)
					                  { // Format "offen zu" fr Kontakte
										if  (Menu.Ascii[0]==1)
						                    {print_Str("offen",font,xleft+font_width,ytop,foo_color,gnd_color);}
					   	                else{print_Str(" zu  ",font,xleft+font_width,ytop,foo_color,gnd_color);}
						              }
                                  else{ // Format "Aus An" fr Relais/B-Programme
					                    if  (Menu.Ascii[0]==1)
								            {print_Str("offen",font,xleft+font_width,ytop,foo_color,gnd_color);}
					   	                else{print_Str(" zu  ",font,xleft+font_width,ytop,foo_color,gnd_color);}
                                      }
                                }
                          }
                    }
              }
          if  (typ <3)
		      {
		        if  (typ==1)
		            { if  (num==0) {print_Str("Sek",font,xleft+font_width,ytop,txt_color,gnd_color);}
			          if  (num==1) {print_Str("Min",font,xleft+font_width,ytop,txt_color,gnd_color);}
			        }
                if  ((typ==1 && num>1 && num<5) || (typ==2 && !num))
		            { print_Str("Uhr",font,xleft+font_width,ytop,txt_color,gnd_color);}
              }
          else{ switch(typ)
	                  {
				        case 3: print_Str("pH" ,font,xleft+font_width,ytop,txt_color,gnd_color); break; // pH
				        case 4: print_Str("EC" ,font,xleft+font_width,ytop,txt_color,gnd_color); break; // EC
		                case 5: print_Str("`C" ,font,xleft+font_width,ytop,txt_color,gnd_color); break; // C
		          	    case 8: print_Str("L"  ,font,xleft+font_width,ytop,txt_color,gnd_color); break; // Liter
				  		case 9: print_Str("Lux",font,xleft+font_width,ytop,txt_color,gnd_color); break; // Lux
				  		default:print_Str("%"  ,font,xleft+font_width,ytop,txt_color,gnd_color); break; // LuftFeuchte und Bodenfeuchte
                      }
              }
        } // ENDE --- Value ausgeben---
  }



/*************************************
 Funktion Monat als Schrift ausgeben
  parameter: format 0= Feb Mr usw
                    1= Februar Mrz
             monat
             font  
			 xleft
			 ytop
			 fontfarbe
			 grundfarbe
**************************************/
void monat_ausgabe(uint8_t monat,uint8_t format,uint8_t font,uint8_t xleft,uint16_t ytop,uint16_t fg_clr,uint16_t bg_clr)
  {
    if  (format ==0)
	    {
          switch(monat)
                {
		          case  1: print_Str ("Jan.",font,xleft,ytop,fg_clr,bg_clr); break; 
		          case  2: print_Str ("Feb.",font,xleft,ytop,fg_clr,bg_clr); break; 
			      case  3: print_Str ("M{rz",font,xleft,ytop,fg_clr,bg_clr); break;
			      case  4: print_Str ("Apr.",font,xleft,ytop,fg_clr,bg_clr); break;
			      case  5: print_Str ("Mai" ,font,xleft,ytop,fg_clr,bg_clr); break;
			      case  6: print_Str ("Juni",font,xleft,ytop,fg_clr,bg_clr); break;
			      case  7: print_Str ("Juli",font,xleft,ytop,fg_clr,bg_clr); break;
			      case  8: print_Str ("Aug.",font,xleft,ytop,fg_clr,bg_clr); break;
			      case  9: print_Str ("Sep.",font,xleft,ytop,fg_clr,bg_clr); break;
			      case 10: print_Str ("Okt" ,font,xleft,ytop,fg_clr,bg_clr); break;
			      case 11: print_Str ("Nov.",font,xleft,ytop,fg_clr,bg_clr); break;
			      case 12: print_Str ("Dez.",font,xleft,ytop,fg_clr,bg_clr); break;
                }
        }
    else{
	      switch(monat)
                {
		          case  1: print_Str ("Januar",font,xleft,ytop,fg_clr,bg_clr);    break; 
		          case  2: print_Str ("Februar",font,xleft,ytop,fg_clr,bg_clr);   break; 
			      case  3: print_Str ("M{rz",font,xleft,ytop,fg_clr,bg_clr);      break;
			      case  4: print_Str ("April",font,xleft,ytop,fg_clr,bg_clr);     break;
			      case  5: print_Str ("Mai" ,font,xleft,ytop,fg_clr,bg_clr);      break;
			      case  6: print_Str ("Juni",font,xleft,ytop,fg_clr,bg_clr);      break;
			      case  7: print_Str ("Juli",font,xleft,ytop,fg_clr,bg_clr);      break;
			      case  8: print_Str ("August",font,xleft,ytop,fg_clr,bg_clr);    break;
			      case  9: print_Str ("Septemper",font,xleft,ytop,fg_clr,bg_clr); break;
			      case 10: print_Str ("Oktober" ,font,xleft,ytop,fg_clr,bg_clr);  break;
			      case 11: print_Str ("November",font,xleft,ytop,fg_clr,bg_clr);  break;
			      case 12: print_Str ("Dezember",font,xleft,ytop,fg_clr,bg_clr);  break;
                }
        }
  }



/**************************************
 Funktion Cursor set
 **************************************/
void cursor_set()
   {
   /*  if  (Menu.Eingabe==0)
	     {
		   // Cursor Position fr SensorTyp einstellen
 	       switch(Menu.SenTyp)
	 	 	  {
	     		 case  1: Menu.Cursor =5; break; // 24h-Uhr
				 case  2: Menu.Cursor =4; break; // WochenUhr
				 case  3: Menu.Cursor =5; break; // Datum
				 case  4: Menu.Cursor =5; break; // Trigger
				 case  5: Menu.Cursor =3; break; // C
				 case  6: Menu.Cursor =3; break; // RLF
		 		 case  7: Menu.Cursor =0; break; // Kontakt
				 case  8: Menu.Cursor =2; break; // PWM
       		   }
     	   // Anzeige Wert zurckstellen
     	   for (uint8_t i=0;i<=5;i++) {Menu.Value[i] =0;}
         }
     else{ // Cursor Position fr Label
	       Menu.Cursor =9;
         }
*/
   }



/*****************************************
Funktion setzt (wert>0) einen Btn Wert oder
gibt einen Btn wert zurck (wert=0)
******************************************/
uint16_t btn_wert(uint16_t wert, uint8_t tab)
  {

     if  (Menu.Window==Haupt_Menu) 
	     {
		   switch(tab)
		         { case 12: if  (!wert) {return RAM_Data.SenTyp;} else{RAM_Data.SenTyp =wert;} break; // SenTyp
		           case 13: if  (!wert) {return RAM_Data.SenNum;} else{RAM_Data.SenNum =wert;} break; // SenNum
				   case 14: if  (!wert) {return RAM_Data.AnzTyp;} else{RAM_Data.AnzTyp =wert;} break; // AnzTyp
				   case 15: if  (!wert) {return RAM_Data.AnzOp1;} else{RAM_Data.AnzOp1 =wert;} break; // AnzOp1
				   case 16: if  (RAM_Data.AnzTyp >2 && RAM_Data.AnzTyp <7 && RAM_Data.SenTyp >9) // Liste?
				                { if  (!wert){return Menu.bit16_1;}else{Menu.bit16_1=wert;} } // Listen Seite
                            else{ if  (!wert){return RAM_Data.AnzOp2;} else{RAM_Data.AnzOp2 =wert;} } // TextFarbe(Felder) oder Auflsung(Charts)
				   break;
                 }
         }
     else{ if  (tab==15 || tab==53 || tab==4)             // bit1_1
		       { if  (!wert) {return Menu.bit1_1;}else{Menu.bit1_1 =wert;}
			   }
           else{ if  (tab==16 || tab==55 || tab==5)       // bit1_2
		             { if  (!wert) {return Menu.bit1_2;}else{Menu.bit1_2 =wert;}
					 }
	             else{ if  (tab==17 || tab==57 || tab==7) // bit1_3
		                   { if  (!wert) {return Menu.bit1_3;}else{Menu.bit1_3 =wert;}
						   }
	                   else{ if  (Menu.Window==Relais_Menu && tab==4)       // bit2_1
		                         { if  (!wert) {return Menu.bit2_1;}else{Menu.bit2_1 =wert;}
								 }
                             else{ if  (tab==75 || tab==14)                 // bit2_2
                                       { if  (!wert) {return Menu.bit2_2;}else{Menu.bit2_2 =wert;}
									   }
                                   else{ if  (tab==54 || tab==2 || (Menu.Window==Relais_Menu && tab==5))       // bit4_1
		                                     { if  (!wert) {return Menu.bit4_1;}else{Menu.bit4_1 =wert;}
											 }
                                         else{ if  (tab==12 || tab==77 || (Menu.Window==Info_Menu && tab==3)) // bit4_2
		                                           { if  (!wert) {return Menu.bit4_2;}else{Menu.bit4_2 =wert;}
												   }
                                               else{ if  (tab==13)                                             // bit4_3
		                                                 { if  (!wert) {return Menu.bit4_3;}else{Menu.bit4_3 =wert;}
														 }
                                                     else{ if  (Menu.Window==Relais_Menu && tab==3) // bit6_1
		                                                       { if  (!wert) {return Menu.bit6_1;}else{Menu.bit6_1 =wert;}
															   }
                                                         }
                                                   }
                                             }
                                       }
                                 }
                           }
                     }
               }
         }
    return 0;
  }



/*****************************************
Funktion gibt die Sensoren Anzahl zurck.
******************************************/
uint8_t sens_anzahl(uint8_t sensor)
  {
    switch(sensor)
	      { case  0: return  0; break;
		    case  1: return  5; break; //  6 Zeitperioden; Min Stunde Tag Woche Monat Jahr
		    case  2: return  1; break; //  2 Zeitpunkte;   Uhrzeit Datum
			case  3: return  1; break; //  2 pH Sonden
			case  4: return  1; break; //  2 EC Sonden
			case  5: return  3; break; //  4 SHT Sensoren
			case  6: return  3; break; //  4 "   "
			case  7: return  7; break; //  8 Bodenfeuchte Sensoren
			case  8: return  3; break; //  4 Fllstands Sensoren
			case  9: return  3; break; //  4 Licht Sensoren
			case 10: return  7; break; //  8 Kontakte
			case 11: return 15; break; // 16 Relais
			case 12: return  3; break; //  4 B-Programme
          }
    return 0;
  }



/*****************************************
Funktion gibt die Anzahl der 1.Option fr die Anzeige zurck
******************************************/
uint8_t opt1_anzahl(uint8_t anzeigetyp)
  {
    if  (anzeigetyp <3 || anzeigetyp>6) 
	    { return 15;} // Farbauswahl Btn (0-15)
    else{ 
	      switch(anzeigetyp)
	            { case 3: return  6; break; // Tages Chart   (0- 6) ergibt 1-7
	              case 4: return  4; break; // Wochen Chart  (0- 4)
			      case 5: return 11; break; // Monats Chart  (0-11)
			      case 6: return  9; break; // Jahres Charts (0- 9)
			      default:return  0; break;
			    }
        }
  }



/*****************************************
Funktion gibt die Anzahl der 2.Option fr die Anzeige zurck
******************************************/
uint16_t opt2_anzahl(uint8_t anzeigetyp)
  {
    if  (anzeigetyp <3 || anzeigetyp>6) 
	    { return 3;} // TextFarbauswahl Btn (0-3)
    else{ if  (RAM_Data.SenTyp <10)
	          {return  15;} // Chart Auflsung
	      else{return Menu.bit16_1;} // Seitenanzahl insg. fr die Liste (ergibt sich aus der Menge der Logdaten)
	    }
  }



/***********************************
 Funktion Tag als Schrift ausgeben
 parameter[in]: dow(day of week) 1=Mo bis 7=So
 TextString in dataString abgelegt
 return Anzahl der Buchstaben des Tages
 ***********************************/
uint8_t tag_zu_text(uint8_t tag)
  {
    switch(tag)
          {
		    case 1: strcpy((char*)dataString, "Montag" );    return  6; break;
		    case 2: strcpy((char*)dataString, "Dienstag");   return  8; break; 
			case 3: strcpy((char*)dataString, "Mittwoch");   return  8; break;
			case 4: strcpy((char*)dataString, "Donnerstag"); return 10; break;
			case 5: strcpy((char*)dataString, "Freitag");    return  7; break;
			case 6: strcpy((char*)dataString, "Samstag");    return  7; break;
			case 7: strcpy((char*)dataString, "Sonntag");    return  7; break;
	      }
    return 0;
  }



/****************************************************************************
 Funktion gibt Monat als TextString zurck
 Parameter[in]; monat
 Rckgabewert:  Anzahl der Buchstaben des Monats
 Monat wird als String in dataString[] abgelegt
 ****************************************************************************/
uint8_t monat_zu_text(uint8_t monat)
  {
    switch(monat)
		  {
		    case  1: strcpy((char*)dataString, "Januar" );   return 6; break;
		    case  2: strcpy((char*)dataString, "Februar" );  return 7; break;
		    case  3: strcpy((char*)dataString, "M{rz" );     return 4; break;
		    case  4: strcpy((char*)dataString, "April" );    return 5; break;
		    case  5: strcpy((char*)dataString, "Mai" );      return 3; break;
		    case  6: strcpy((char*)dataString, "Juni" );     return 4; break;
		    case  7: strcpy((char*)dataString, "Juli" );     return 4; break;
		    case  8: strcpy((char*)dataString, "August" );   return 6; break;
		    case  9: strcpy((char*)dataString, "September" );return 9; break;
		    case 10: strcpy((char*)dataString, "Oktober" );  return 7; break;
		    case 11: strcpy((char*)dataString, "November" ); return 8; break;
		    case 12: strcpy((char*)dataString, "Dezember" ); return 8; break;
			default: return 0; break;
		  }
  }



/****************************************************************************
 Funktion gibt die anzahl der mglichen charts des jeeiligen Anzeigetypes zurck
 ****************************************************************************/
 uint8_t last_next(void)
  {
    switch(RAM_Data.AnzTyp)
	      {
	        case 3: return  7; break; // Tageschart (immer 1 weniger, 0 =aktueller chart)
		    case 4: return  5; break; // Wochenchart
		    case 5: return 12; break; // Monatschart 
		    case 6: return 10; break; // Jahreschart
          }
    return 0;
  }



/****************************************************************************
 Funktion schreibt Min Max Wert in die Chartkopfzeile
 Parameter[in]; sen_typ
 ****************************************************************************/
void chart_minmax(void)
  {
	 color_set(Hintergrund);
     Rectan(60,23,179,39,0,Menu.Farbe.Grund,1); // Anzeige Felder lschen
     label_value(6, RAM_Data.SenTyp, RAM_Data.SenNum, 1, 60, 33, Menu.Farbe.Text,     Menu.Farbe.Grund); // Aktueller Wert ausgeben
	 label_value(8, RAM_Data.SenTyp, RAM_Data.SenNum, 1,116, 33, Menu.Farbe.TextGruen,Menu.Farbe.Grund); // Minimal Wert
	 label_value(9, RAM_Data.SenTyp, RAM_Data.SenNum, 1,172, 33, Menu.Farbe.TextRot,  Menu.Farbe.Grund); // Maximal Wert
  }



/****************************************************************************
 Funktion gibt SensorTyp/Num einer Arrayziffer fr Value[] oder Label[] zurck.
 Parameter[in]; flag 0   =SensorTyp aus ArrayNr(num) erzeugen
                     1   =SensorNum aus ArrayNr(num) erzeugen
					 2   =ArrayNr aus (typ) und (num) erzeugen
                typ
                num  
 Rckgabewert ; bei flag0=SensorTyp
                "   "   1=SensorNum
				"   "   2=Array Num
 ****************************************************************************/
uint8_t array_zu_sentyp(uint8_t flag, uint8_t typ, uint8_t num)
  { // 0,1=pH 2,3=EC 4-11=SHT 12-19=BodenF 20-23=Fllst 24-27=Licht 28-35=Kontakte
    // 36-51=Relais 52-55=DosProgr. 56-64=DosPump. 65-68=Magn.Ventile
    
	if  (flag <2)
	    { // SensorTyp oder SensorNum aus ArrayZiffer(num) zurckgeben  
	      if  ( num < 2)
	          { if  (flag) {return num;}else{return 3;}} // pH
	      else{ if  ( num < 4)
	                { if  (flag) {return num -2;}else{return 4;}} // EC
                else{ if  ( num < 8)
		                  { if  (flag) {return num -4;}else{return 5;}} // SHT Temp
			          else{ if  ( num < 12)
				                { if  (flag) {return num -8;}else{return 6;}} // SHT Feuchte
                            else{ if  ( num < 20)
					                  { if  (flag) {return num -12;}else{return 7;}} // BodenFeuchte
                                  else{ if  ( num < 24)
							                { if  (flag) {return num -20;}else{return 8;}} // Fllstand
                                        else{ if  ( num < 28)
								                  { if  (flag) {return num -24;}else{return 9;}} // Licht
                                              else{ if  ( num < 36)
										                { if  (flag) {return num -28;}else{return 10;}} // Kontakte
											        else{ if  ( num < 52)
											                  { if  (flag) {return num -36;}else{return 11;}} // Relais
                                                          else{ if  ( num < 56)
													                { if  (flag) {return num -52;}else{return 12;}} // B-Programm
                                                                else{ if  ( num <65)
														                  { if  (flag) {return num -56;}else{return 13;}} // Dos.Pumpe
                                                                      else{ if  (flag) {return num -65;}else{return 14;}} // Mag.Ventil
                                                                    }
                                                              }
                                                        }
                                                  }
											}
                                      }
                                }
                          }
                    }
              }
        }
    else{ // Array Ziffer aus (typ) und (num) zurckgeben
	      switch(typ)
		        { case  3: return num +typ - 3; break; // pH[0,1]
				  case  4: return num +typ - 2; break; // EC[2,3]
				  case  5: return num +typ - 1; break; // SHT C[4-7]
				  case  6: return num +typ + 2; break; // SHT rLF[8-11]
				  case  7: return num +typ + 5; break; // Boden-Feuchte[12-19]
				  case  8: return num +typ +12; break; // Fllstand[20-23]
				  case  9: return num +typ +15; break; // Licht[24-27]
				  case 10: return num +typ +18; break; // Kontakt[28-35]
				  case 11: return num +typ +25; break; // Relais[36-51]
				  case 12: return num +typ +40; break; // B-Programm[52-55]
				  case 13: return num +typ +43; break; // Dosierpumpe[56-64]
				  case 14: return num +typ +51; break; // MagnetVentil[65-68]
                }
	    }
    return 0;
  }



/****************************************************************************
 Funktion zeichnet eine Tabelle fr die Logeintrge
 ****************************************************************************/
void list_draw(void)
 {
   color_set(RAM_Data.Farbe.Grund);
   if  (RAM_Data.SenTyp==6)
       {
	     print_Str("Auf",2, 48,36,Menu.Farbe.Text,Menu.Farbe.Grund);
         print_Str("Zu" ,2,172,36,Menu.Farbe.Text,Menu.Farbe.Grund);
	   }
   else{
         print_Str("Ein",2, 48,36,Menu.Farbe.Text,Menu.Farbe.Grund);
         print_Str("Aus",2,172,36,Menu.Farbe.Text,Menu.Farbe.Grund);
	   }
   for (uint8_t i =0; i<11; i++) {Line(2, (i *10)+41, 237, (i *10)+41, 1, Weiss6);}
   Line(119, 27, 119, 151, 1, Weiss6);
 }




/******************************************************************************
 Funktion gibt die Anzahl der Tage eines Monats zurck
 Parameter[in];
 monat; 1-12 fr Jan. bis Dez.
 ******************************************************************************/
uint8_t tage_im_monat(uint8_t monat, uint16_t jahr)
  {
    switch(monat)
	      {
		    case  1: return 31; break;
			case  2: if  (schaltjahr(jahr)) {return 29;} else {return 28;} break;
			case  3: return 31; break;
			case  4: return 30; break;
			case  5: return 31; break;
			case  6: return 30; break;
			case  7: return 31; break;
			case  8: return 31; break;
			case  9: return 30; break;
			case 10: return 31; break;
			case 11: return 30; break;
			case 12: return 31; break;
            default: return  0; break;
          }
  }



/****************************************************************************
 Funktion gibt den Wochentag eines Datums zurck,
 return 1=Mo 2=Di 3=Mi 4=Do 5=Fr 6=Sa 7=S
 formelursprung;
 0 bis 6 (So, Mo, Di, Mi, Do, Fr, Sa) ?
 ****************************************************************************/
uint8_t wochentag(uint8_t tag, uint8_t monat, uint16_t jahr)
  {
    int8_t a = tag % 7;
	int8_t b = 0;
	if  (monat >1) {b = tage_im_monat(monat-1,jahr) % 7;}
    int8_t c = jahr%100;
	c = (c +(c /4)) % 7;
    int8_t d = jahr/100;
	d = (3 - (d % 4)) *2;
	int8_t e =0;
	if  (schaltjahr(jahr)) {e =6;}
	uint8_t wtag = (a + b + c + d + e) % 7;
	if  (!wtag)
	    {wtag =7;}
	return wtag;
  }



/****************************************************************************
 Funktion prft ob es sich um ein Schaltjahr handelt
 rckgabe 1=ja, 0=nein
 ****************************************************************************/
uint8_t schaltjahr(uint16_t jahr)
   {
      if  (jahr %4 ==0 || jahr %400 ==0) {return 1;} else {return 0;}
   }



/****************************************************************************
 Funktion ermittelt die TagesNr des Jahres
 rckgabewert: TagesNr
 ****************************************************************************/
uint16_t tagesnummer(uint8_t tag, uint8_t monat, uint16_t jahr)
   {
     return tag +489 *monat /16 -(7 +monat) /10 *(2 -schaltjahr(jahr)) -30;
   }



/****************************************************************************
 Funktion rechnet Tagesnummer und Jahr in Tag & Monat um
 ****************************************************************************/
uint16_t tag_monat(uint16_t tagesnummer, uint16_t jahr)
  {
    uint8_t SJ    = schaltjahr(jahr);
    uint8_t Tk    = tagesnummer + 30 + (tagesnummer + SJ + 400) / 460 *(2 - SJ);  // Tag-Korrekturwert wegen Januar, Februar und Schaltjahr
    uint8_t Monat = Tk  * 16 / 489;
    uint8_t Tag   = tagesnummer + 30 - 489 * Monat / 16 + (7 + Monat) / 10 *(2 - SJ);
    return Tag * 100 + Monat;
  }



/****************************************************************************
 Funktion prft das bergebene Datum auf Feiertag oder Sommer/Winterzeit Anfang.
 Name des Feiertages wird in dataString[] abgelegt.
 
 return 0 = kein besonderer Tag
 Return 1 = Feiertag oder Sommer/Winterzeit Anfang aber kein gesetzlicher Feiertag
 Return 2 bis 65535 = Feiertag in einigen Bundeslndern. (Summe der Werte aus folg. Tabelle)
 +-----+-----+----+----+----+----+---+---+---+--+--+--+--+--+--+--+
 |  TH |  SH | ST | SN | SL | RP | NW| NI| MV|HE|HH|HB|BB|BE|BY|BW|
 +-----+-----+----+----+----+----+---+---+---+--+--+--+--+--+--+--+
 |32768|16384|8192|4096|2048|1024|512|256|128|64|32|16| 8| 4| 2| 1|

  Lnderabkrzungen;
  BW                     | NI	           | BY	     | BB
  Baden-Wrttemberg	     | Niedersachsen   | Bayern  | Brandenburg	
  NW	                 | ST	           | BE	     | SN	
  Nordrhein-Westfalen    | Sachsen-Anhalt  | Berlin  | Sachsen
  SH	                 | RP              | HH	     | SL	
  Schleswig-Holstein     | Rheinland-Pfalz | Hamburg | Saarland
  MV	                 | TH	           | HB	     | HE	
  Mecklenburg-Vorpommern | Thringen       | Bremen  | Hessen
  ****************************************************************************/
uint16_t feiertag(uint8_t tag, uint8_t monat, uint16_t jahr)
  {
    dataString[0] ='\0';
    
    // feste Feiertage
    if  (monat== 1 && tag== 1) {strcat((char*)dataString,"Neujahr");             return 65535;}
    if  (monat== 1 && tag== 6) {strcat((char*)dataString,"Heilige Drei K|nige"); return  8195;}
    if  (monat== 3 && tag==29) {strcat((char*)dataString,"Karfreitag");          return 65535;}
    if  (monat== 5 && tag== 1) {strcat((char*)dataString,"1.Mai");               return 65535;}
    if  (monat== 8 && tag==15) {strcat((char*)dataString,"Mari Himmelfahrt");   return  2048;}
    if  (monat==10 && tag== 3) {strcat((char*)dataString,"Tag d. dt. Einheit");  return 65535;}
    if  (monat==10 && tag==31) {strcat((char*)dataString,"Reformationstag");     return 45192;}
    if  (monat==11 && tag== 1) {strcat((char*)dataString,"Allerheiligen");       return  3587;}


    // bewegliche Feiertage die an das Osterdatum gekoppelt sind...
    // http://manfred.wilzeck.de/Datum_berechnen.html#Osterdatum_berechnen
    // (3) Einfache Berechnung fr Ostersonntag. JAHR (4-stellig) 1900 bis 2099 mit Ergnzung bis 2199
    int16_t a = (jahr % 19 * 19 + 24) % 30;           // (Jahr 4-stellig)
    int16_t b = 120 + a - a / 27;                     // mit Ergnzung fr Jahre 1954, 1981, 2049 und 2076
    int16_t c = (b + jahr * 5 / 4 - jahr / 2100) % 7; // mit Ergnzung gltig bis 2199
    int16_t E = b - c;                                // E = Osterkennzahl (Easter), Bezugswert fr alle beweglichen Feiertage

    if  (tag == 1 + E % 31 && monat == E / 31) {strcat((char*)dataString,"Ostersonntag"); return 65535;} // Ostersonntag (alle Bundeslnder)
   
    // (6)&(7) Weiberfastnacht(-52), Rosenmontag(-48), Aschermittwoch(-46),Palmsonntag (-7), Grndonnerstag (-3),
	// Karfreitag(-2), Ostermontag(+1), Himmelfahrt(+39), Pfingsten(+49) und Fronleichnam (+60)
    int8_t  d = 0;
    int16_t f = 0;
    int16_t g = 0;

    for (int8_t i =0; i < 9; i++)
        {
	      switch(i)
	 	        {
			      case 0: d = -52; break; // Weiberfastnacht
			      case 1: d = -48; break; // Rosenmontag
			  	  case 2: d = -46; break; // Aschermittwoch
			 	  case 3: d = - 7; break; // Palmsonntag
				  case 4: d = - 2; break; // Karfreitag
				  case 5: d =   1; break; // Ostermontag
				  case 6: d =  39; break; // Himmelfahrt
				  case 7: d =  49; break; // Pfingstmontag
				  case 8: d =  60; break; // Fronleichnam
                }

		  f = E + d;
          g = f + f / 154 - 92 / f * (3 - schaltjahr(jahr));
   
          switch(i)
		        {
			      case 0: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Weiberfastnacht"); return     1;} break;
                  case 1: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Rosenmontag");     return     1;} break;
		          case 2: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Aschermittwoch");  return     1;} break;
		          case 3: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Palmsonntag");     return     1;} break;
                  case 4: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Karfreitag");      return 65535;} break;
                  case 5: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Ostermontag");     return 65535;} break;
		 	 	  case 6: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Himmelfahrt");     return 65535;} break;
				  case 7: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Pfingstmontag");   return 65535;} break;
				  case 8: if  (tag == 1 + g % 31 && monat == g / 31) {strcat((char*)dataString,"Fronleichnam");    return  3651;} break;
                }
        }

    // (8) Berechnung der anderen beweglichen Feiertage mit der Osterkennzahl
	// Diese Tage haben keine feste Distanz zu Ostern, aber sie hngen trotzdem an Ostern, weil dessen Sonntag mit dem Datum verkoppelt ist.
    if  (tag == 16 + E % 7 && monat == 11)     {strcat((char*)dataString,"Bu- und Bettag"); return 4096;} // Datum Tag fr Bu- und Bettag (Mittwoch) im November (mglich ist 16. bis 22.11.)
    if  (tag ==  8 + E % 7 && monat ==  5)     {strcat((char*)dataString,"Muttertag");       return    1;} // Datum Tag fr Muttertag (2. Sonntag) im Mai
    if  (tag == 25 +(E + 2) % 7 && monat == 3) {strcat((char*)dataString,"Sommerzeit");      return    1;} // Datum Tag fr Beginn Sommerzeit im Mrz
    if  (tag == 25 +(E + 5) % 7 && monat ==10) {strcat((char*)dataString,"Winterzeit");      return    1;} // Datum Tag fr Ende Sommerzeit im Oktober
    if  (tag == 18 + E % 7 && monat == 12)     {strcat((char*)dataString,"4.Advent");        return    1;} // Datum Tag fr 4. Advent im Dezember, frhest mglicher Tag ist 18 und sptest mglicher Tag ist 18+6 = 24. Dezember
    if  (tag == 11 + E % 7 && monat == 12)     {strcat((char*)dataString,"3.Advent");        return    1;} // Datum Tag fr 3. Advent im Dezember
    if  (tag ==  4 + E % 7 && monat == 12)     {strcat((char*)dataString,"2.Advent");        return    1;} // Datum Tag fr 2. Advent im Dezember
    if  (tag ==  1 +(26 + E % 7) % 30)         {strcat((char*)dataString,"1.Advent");        return    1;} // Datum Tag fr 1. Advent im Dezember / November
    return 0;
  }




/*******************************************************************************************************************************
 Funktion Button Symbole 10x10 px
 *************************  0 1 2 3 4 5 6 7 8 9 10|   0 1 2 3 4 5 6 7 8 9 10 |   0 1 2 3 4 5 6 7 8 9 10 |   0 1 2 3 4 5 6 7 8 9 10
 Parameter:               0           *           | 0           *            | 0     * * * * * * *      | 0           *
 - symbol: 0=Pfeil n.oben 1         *   *         | 1         * *            | 1     *           *      | 1           * *
           1=Pfeil n.link 2       *       *       | 2       *   * * * * * *  | 2     *           *      | 2 * * * * * *   *
           2=Pfeil n.unte 3     *           *     | 3     *               *  | 3     *           *      | 3 *               *
           3=Pfeil n.rech 4   *               *   | 4   *                 *  | 4     *           *      | 4 *                 *
   xleft : X-Pos          5 * * *           * * * | 5 *                   *  | 5 * * *           * * *  | 5 *                   *
   ytop  : Y-Pos          6     *           *     | 6   *                 *  | 6   *               *    | 6 *                 *
   fg_clr: Farbe 		  7     *           *     | 7     *               *  | 7     *           *      | 7 *               *
						  8	    *           *     | 8       *   * * * * * *  | 8       *       *        | 8 * * * * * *   *
                          9     *           *     | 9         * *            | 9         *   *          | 9           * *
						 10     * * * * * * *     |10           *            |10           *            |10           *
 *******************************************************************************************************************************/
void symbole(uint8_t symbol, uint8_t xleft, uint16_t ytop, uint16_t fg_clr)
  {
   switch(symbol)
     {case  0: // Pfeil nach oben
	    Line(xleft+5,ytop,  xleft,  ytop+5,  1,fg_clr); Line(xleft+5,ytop,  xleft+10,ytop+5, 1,fg_clr); //   ^
        Line(xleft,  ytop+5,xleft+2,ytop+5,  1,fg_clr); Line(xleft+8,ytop+5,xleft+10,ytop+5, 1,fg_clr); // -   -
	    Line(xleft+2,ytop+5,xleft+2,ytop+10, 1,fg_clr); Line(xleft+8,ytop+5,xleft+8, ytop+10,1,fg_clr); //  | |
	    Line(xleft+2,ytop+10,xleft+8,ytop+10,1,fg_clr);                                                 //   -
	  break;
	  case  1: // Pfeil nach links
	    Line(xleft+5,ytop,   xleft,  ytop+5, 1,fg_clr); Line(xleft+5,ytop,  xleft+5,ytop+2, 1,fg_clr); // /'
	    Line(xleft,  ytop+5, xleft+5,ytop+10,1,fg_clr); Line(xleft+5,ytop+8,xleft+5,ytop+10,1,fg_clr); // \,
  	    Line(xleft+5,ytop+2, xleft+10,ytop+2, 1,fg_clr); Line(xleft+5,ytop+8,xleft+10,ytop+8, 1,fg_clr); //   =
	    Line(xleft+10,ytop+2, xleft+10,ytop+8, 1,fg_clr);                                                //    |
      break;
	  case 2: // Pfeil nach unten
	    Line(xleft+2,ytop,xleft+8,ytop, 1,fg_clr);                                                  //   -
		Line(xleft+2,ytop,xleft+2,ytop+5, 1,fg_clr); Line(xleft+8, ytop,xleft+8, ytop+5, 1,fg_clr); //  | |
		Line(xleft,  ytop+5,xleft+2,ytop+5, 1,fg_clr); Line(xleft+8, ytop+5,xleft+10,ytop+5, 1,fg_clr); // -   -
		Line(xleft,  ytop+5,xleft+5,ytop+10,1,fg_clr); Line(xleft+10,ytop+5,xleft+5 ,ytop+10,1,fg_clr); //  \ /
      break;
	  case 3: // Pfeil nach rechts
	    Line(xleft,ytop+2,xleft, ytop+8,1,fg_clr);                                                  // |
		Line(xleft,ytop+2,xleft+5,ytop+2,1,fg_clr); Line(xleft,ytop+8, xleft+5, ytop+8, 1,fg_clr); //  =
		Line(xleft+5,ytop,  xleft+5, ytop+2,1,fg_clr); Line(xleft+5,ytop+8, xleft+5, ytop+10,1,fg_clr); //   :
		Line(xleft+5,ytop,  xleft+10,ytop+5,1,fg_clr); Line(xleft+5,ytop+10,xleft+10,ytop+5, 1,fg_clr); //    >
      break;
     }
  }














