/* Things to do 

  - DosierWerte gehn nur bis 255, besser wre 999

  - Bei Stromausfall oder Unterspannung werden mithilfe einer Pufferschaltung folgende Daten
    im EEPROM gespeichert;
    * Zeitstempel Strung; Datum/ Uhrzeit
	* Men Einstellungen ; RAM_Data.AnzTyp (Anzeige Typ)
						   RAM_Data.SenTyp (Sensor Typ)
						   RAM_Data.SenNum (Sensor Nummer)
	                       RAM_Data.AnzOp1 (Anzeige Option1)
						   RAM_Data.AnzOp2 (Anzeige Option2)
    
  - Sollte sich die Software aufhngen resetiert der Watch Dog des Atmegas den Automaten.
    Hierbei kann nichts gespeichert werden, Fehler mssen in neuer Softw.Version entfernt werden.

  Nach Neustart geht der Automat nach Re-Initialisierung wieder in den normalen Betrieb ber.
  Ein Info-Protokoll mit Zeitstempel und Art der Strung wird erstellt.
	 http://www.mikrocontroller.net/articles/Brownout
	 http://www.mikrocontroller.net/articles/Speicher#EEPROM_Schreibzugriffe_minimieren

  Nach einer Strung wie Stromausfall,Unterspannung oder Software Crash blinkt im Info-Feld des 
  ein Symbol auf. Nach drcken aufs Info-Feld wird das Info-Protokoll sichtbar welches Zeitstempel
  und Art der Strung enthlt und die Strmeldung im Hauptmen verschwindet wieder.

  - Im Kalender knnen Termine(Tag) oder Zeitrume(mehrere Tage) angelegt werden. Ausserdem werden
    im Kalender alle deutschen Feiertage angezeigt.
    Die Feiertage und die selbst angelegten Termine/Zeitrume werden im Hauptmen auf der groen
	Digital Uhr angezeigt. Schneidet sich ein angelegter Termin mti einem Feiertag wird nur der
	angelegte Termin angezeigt.
*/


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Datei Name             : SMR-Automat_V1.0.c
  Editor                 : AVR Studio 4.18 Build 700
  Compiler               : WinAVR-20100110
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  MCU                    : ATMEL AVR-MEGA2560 mit 16Mhz Quarz auf Modul
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Touch Farb Display     : ET-TFT240320 TP3.1 Rev.c
  - Device ID            : 0(IM0=0))
  - Display Format       : Vertikal = Hochkant
  - Port Interface       : 16Bit Modus
  - Data GLCD            : PA[0..7]        Connect: DB0..DB7
  -                      : PC[0..7]        Connect: DB8..DB15
  - Control GLCD         : PE2 	           Connect: CS-H
  -                      : PE3	           Connect: RS-H(0=cmm,1=data)
  -                      : PE4	           Connect: WR-H(Write)
  -                      : PE5             Connect: RD-H(Read)
  -                      : PE6	           Connect: RES-H(Reset)
  - Back Light GLCD      : PE7	           Connect: BL-H(LCD-Back Light(Active=1))
  - Touch Screen         : PH2 (MISO-in)   Connect: MISO
  -                      : PH3 (MOSI-out)  Connect: MOSI
  -                      : PH4 (SCLK-out)  Connect: SCLK
  -                      : PH5 (BUSY-in)   Connect: BUSY(No_USE)
  -                      : PH6 (PEN-in)    Connect: PEN
  -                      : PH7 (TC_CS-out) Connect: TC_CS
  - UART0:BaudRate=9600  : PE0 (RXD0)
  -                      : PE1 (TXD0)
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Conrad DCF-77 Modul (Timer1 fr die DCF Signalauswertung)
  Klemmenbild & Source   : http://www.ulrichradig.de/home/index.php/avr/dcf77_uhr
  - Gnd 			     :                          X1:1 Ground
  - VCC			         :                          X1:2 VCC & 10KOhm gegen DCF X1:3
  - DCF-Signal	         : PD3 (Int3)      Connect: X1:3 DCF Signal
  - 				     :                          X1:4
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  SHT11 oder SHT71 (max 4 Stk.)
  Source                 : http://www.mikrocontroller.net/topic/145736#2651000
  Datenblatt             : http://www.sensirion.com/de/produkte/feuchte-temperatur/feuchtesensor-sht11/
  - SHT11_SCL	         : PD1 (SCK)       Connect: gemeinsamer SCK aller SHT Sensoren
  - SHT11_SDA1           : PD4 (Data)      Connect: SHT1 Data
  - SHT11_SDA2           : PD5 (Data)      Connect: SHT2 Data
  - SHT11_SDA3           : PD6 (Data)      Connect: SHT3 Data
  - SHT11_SDA4           : PD7 (Data)      Connect: SHT4 Data
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  Taster & Kontakte (Timer0 fr Tater)     Gehuse-Taster;             [ UP ]
  - ESC_TASTER           : PJ0                             [ESC] [LEFT]      [RIGHT] [ENTER]            
  - LEFT_TASTER          : PJ1                                         [DOWN]     
  - UP_TASTER            : PJ2             Schaltbild;
  - DOWN_TASTER          : PJ3             +-------o< VCC   
  - RIGHT_TASTER         : PJ4             |  
  - ENTER_TASTER         : PJ5             +-+           
  - Kontakt 1            : PK0             | | PullUp ~10k od. intern      
  - Kontakt 2            : PK1             +-+    
  - Kontakt 3            : PK2             |
  - Kontakt 4            : PK3             +-------o< Port
  - Kontakt 5            : PK4             |    
  - Kontakt 6            : PK5                / Kontakt oder Taster
  - Kontakt 7            : PK6              / 
  - Kontakt 8            : PK7             | 
							               +-------o<GND
 http://www.steitec.biz/
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

// interne Header
#include <avr/wdt.h>       // Watchdog
#include <avr/interrupt.h> // Interrupts
#include <math.h>
#include <avr/io.h>
//#include <stdlib.h>        // "itoa ...
#include <stdio.h>
#include <string.h>        // Stringfunktionen fr MMC
#include <avr/pgmspace.h> 
#include <util/delay.h>    // fr MMC notwendig???

// WatchDog aus, MCUSR kopieren & lschen
// http://www.nongnu.org/avr-libc/user-manual/group__avr__watchdog.html
uint8_t mcusr_mirror __attribute__ ((section (".noinit")));
void get_mcusr(void)__attribute__((naked))__attribute__((section(".init3")));
void get_mcusr(void)
    {
	  mcusr_mirror = MCUSR; // MCUSR Register wird in die Variable mcusr_mirror gespeichert
      MCUSR = 0           ; // MCUSR Register lschen
      wdt_disable()       ; // Watch Dog auschalten
    };

// zustzliche Module aus dem Projektverzeichniss
#define extern
#include "msr_unit01.h"       // Main Header
#include "funktionen.h"       // Men Funktionen
#include "buttons.h"          // Btn Funktionen
#include "mmc_readlog.h"      // gelesene Logzeile von MMC auswerten
#include "mmc_funktionen.h"   // MMC Funktionen
#include "update.h"           // Sekunden Update
#include "debug.h"            // Debugmodus fr Fehlersuche
#include "Leds/led.h"         // LED Header
#include "Sound/sound.h"      // Sound Header
#include "Taster/taster.h"         // Taster Header
#include "Kontakte/kontakte.h"     // Reedkontakte, Rauch,-Bewegungsmelder usw.
#include "SHT/sht11.h"             // SHT11 oder 71 Header
#include "Clock/clock.h"           // DCF - Uhr Header
#include "ETT-Display/ett240320tp32revb.h" // ET-TFT Display Header
#include "SD_Card/spi_routines.h"  // SPI Schnittstelle fr MMC Funktionen
#include "SD_Card/sd_routines.h"   // SpeicherKarten Funktionen
#include "SD_Card/uart_routines.h" // UART Terminal Ausgabe
#include "SD_Card/fat32.h"         // FAT32 Funktionen
#include "SD_Card/i2c_routines.h"  // I2C & Funktionen fr DS1307
#undef extern

SaveData EEP_Data EEMEM;


//######################################################################################################
//
//                                        MAIN PROGRAM
//
//######################################################################################################
int main(void)
  {
    // *************************************************************************************************
    //                                 Initialisierungen
    // *************************************************************************************************
    wdt_enable (WDTO_8S); // Watch Dog einschalten (8Sekunden)
    wdt_reset()         ; // " zurck setzen
    
	// --- GLCD Init ---
	bg_color(Schwarz); // Bildschirm lschen
	print_Str(" Mess,-Steuer & Regel Automat ",2,0, 25,Blau3, no_bg);
    print_Str("       MSR-Automat V0.1       ",2,0, 45,Weiss1,no_bg);
    print_Str("    System wird gestartet...  ",2,0, 65,Weiss1,no_bg);
    init_glcd()         ; // GLCD Ini
	
	// --- SHT Init ---
    init_sht11(1)       ; // SHT1
    init_sht11(2)       ; // SHT2
	//init_sht11(3)       : // SHT3
	//init_sht11(4)       : // SHT4
    
	// --- weitere ---
    init_led()          ; // LED Ini
  //init_sound()        ; // Sound Ini
    init_taster()       ; // Taster Ini
    init_clock()        ; // DCF Uhr Ini
    init_kontakte()     ; // Kontakte auf PortK als Eingang
    
	// --- UART ini fr DEBUG ---
    if  (DEBUG)
	    { cli(); init_serial(); sei();
		  transmitString_F(PSTR("*** System Neustart *** \n\r"));
        }

    // --- MMC init ---
    spi_init()          ; // MMC Kommunikation
    twi_init()          ; // IC Kommunikation
    DDRB  = 0xf7; // MISO(PB3) "fr MMC SPI" pull-up off, rest pull-up on
    for (int8_t i=0; i<10; i++)
	    { Menu.MMC_Err =SD_init();
	 	  if  (!Menu.MMC_Err) {break;}
	    }
	if  (Menu.MMC_Err && DEBUG)
        { if  (Menu.MMC_Err ==1) {transmitString_F(PSTR("SD card not detected.."));}
      	  if  (Menu.MMC_Err ==2) {transmitString_F(PSTR("Card Initialization failed.."));}
        }
    else{ Menu.MMC_Err =getBootSectorData (); // read boot sector and keep necessary data in global variables
          if  (Menu.MMC_Err && DEBUG)
		      {transmitString_F (PSTR("\n\rFAT32 not found!"));} // FAT32 incompatible drive
        }
    SPI_HIGH_SPEED;	// SCK - 4 MHz
    _delay_ms(1);   // some delay for settling new spi speed

	// --- KontaktePort Abbild speichern ---
    Kontakte_Port =PINK;
    for (uint8_t i=0; i<7;i++)
        { // Zustand setzen
	      if  ( !(PINK & (1 << (i))))
	 	      { Menu.Kontakt[i] =0;} // Zu
          else{ Menu.Kontakt[i] =1;} // Offen
        }

	// Dosiertabellenwerte lschen
    for  (uint8_t woche=0; woche<15; woche++)
         { for  (uint8_t zeile=0; zeile<9; zeile++)
                { 
				  for  (uint8_t spalte=0; spalte<8; spalte++)
	 	               {Menu.Tabellenwoche[woche].Zeile[zeile].Spalte[spalte] =0;}
                }
         }
    
	// --- Sensormesswerte lschen ---
	for (uint8_t i=0; i<28; i++) {Menu.Value[i] = -32000;}

    update.new_day     =1; // DCF Zeit/Datum, neuer Tag erreicht (in clock.h)
	Menu.Clocked       =0; // Uhrvariablen (hh:mm:ss day.mon.year) wurden noch nicht gestellt
	update.small_clock =1; // groe AnzeigeUhr oder Kalender Uhr/Datum wurde nicht aktualisiert
	update.big_clock   =1; // kleine Uhr im UhrButton wurde nicht aktualisiert
	Menu.bit1_1        =0; // Merker "neue TouchKalib.Daten eingelesen"

	Menu.SHT_Nr        =0; // SHT Sensor[Nummer] welcher als nchstes ausgelesen werden soll
	Menu.TabTimer      =4; // 0 bis  7 (x10Sek.) wann die Button auswahl zurckspringt

	// --- EEPROM in RAM Struktur laden ---
	cli(); // interrupts deaktivieren
    eeprom_read_block(&RAM_Data,&EEP_Data,sizeof(SaveData));
    delay_ms(400);
    sei(); // Interrupts wieder einschalten
    
	// --- EEPROM Grundeinstellung fr den Erststart ---
    if  (RAM_Data.TouchScreenCalibrating.Saved !=1)
        {
		  Menu.DCF_On =1; // DCF
          for (uint8_t i=0; i<16; i++)
              { // 16 Relais
			    label_value(4,11,i,0,0,0,0,0); // Relais Label reseten
	            RAM_Data.Aktor[i].Modus  =0; // Relais Schaltmodus -AUS
	            RAM_Data.Aktor[i].Status =0; // Relais Schaltzustand -AUS
		        RAM_Data.Aktor[i].Option =0; // Relais Einschaltverzgerung -AUS
	 	        for (uint8_t j=0;j<6;j++)
		            { // 6 SchaltBedingungen fr jedes Relais
			          RAM_Data.Aktor[i].Schaltbedingung[j].SenTyp  =0;
			          RAM_Data.Aktor[i].Schaltbedingung[j].SenNum  =0;
			          RAM_Data.Aktor[i].Schaltbedingung[j].Grk    =0;
			          RAM_Data.Aktor[i].Schaltbedingung[j].Neg   =0;
			          RAM_Data.Aktor[i].Schaltbedingung[j].Aor =0;
		              for (uint8_t k=0;k<6;k++) // 6 Werte pro SwitchCondition
					      {RAM_Data.Aktor[i].Schaltbedingung[j].Value[k]=0;}
		            }
              }

          // --- Alle Label reseten ---
          for (uint8_t i=0;i<69; i++)
		      { // (0,1=pH 2,3=EC 4-11=SHT 12-19=BodenF 20-23=Fllst 24-27=Licht 28-35=Kontakte 36-51=Relais 52-55=DosProgr. 56-64=DosPump. 65-68=Magn.Ventile
			    label_value( 4, array_zu_sentyp(0,0,i), array_zu_sentyp(1,0,i), 0, 0, 0, 0, 0);
              }

          RAM_Data.Farbe.Grund  = 1; // Men Hintergrund Farbe 1=Schwarz/ 0=Weiss
          RAM_Data.Farbe.Leiste = 2; // Men Leisten Farbe
          RAM_Data.Farbe.Button = 3; // Men Button Farbe

		  RAM_Data.SenTyp = 0;
	      RAM_Data.SenNum = 0;
	      RAM_Data.AnzTyp = 0;
	      RAM_Data.AnzOp1 = 0;
	      RAM_Data.AnzOp2 = 0;
		  RAM_Data.AnzOp3 = 0;

		  // EEPROM speichern
		  cli(); // interrupts aus
		  eeprom_write_block(&RAM_Data.Farbe, &EEP_Data.Farbe, sizeof(RAM_Data.Farbe));
          eeprom_write_block(&RAM_Data.Label, &EEP_Data.Label, sizeof(RAM_Data.Label));
		  eeprom_write_block(&RAM_Data.Aktor, &EEP_Data.Aktor, sizeof(RAM_Data.Aktor));
	      sei(); // interrupts ein
        }

    bg_color(Schwarz); // Bildschirm lschen

    // Touch Kalibrierungs Daten gefunden
    if  (RAM_Data.TouchScreenCalibrating.Saved ==1)
	    { 
		  print_Str(" Touch Kalibrierung gefunden. ",2,0, 25,Weiss1,Schwarz);
	      print_Str("    In     Sek. werden die    ",2,0, 45,Weiss1,Schwarz);
	      print_Str(" gespeicherten Daten geladen. ",2,0, 65,Weiss1,Schwarz);
  	      print_Str(" <Ber}hre das Display um die> ",2,0,200,Weiss1,Schwarz);
 	      print_Str("  Kalibrierung zu erneuern !  ",2,0,220,Weiss1,Schwarz);
         
		  // Countdown
		  Menu.bit4_1 =  5; // Zhler
          Menu.bit6_1 = ss; // Vergleichsvariable
          print_Zahl(Menu.bit4_1,1,2,57,45,Rot2,Schwarz);
		  do  { 
		 	    if  (Menu.bit6_1 != ss) // jede Sekunde ausfhren
		            {
			 	      Menu.bit6_1 = ss;
			          Menu.bit4_1 --;
		              print_Zahl(Menu.bit4_1,1,2,57,45,Rot2,Schwarz); 
	                }
		      } while (!status_touch() && Menu.bit4_1>0); // Countdown Ablauf solang das GLCD nicht berhrt wird

          // Countdown abgelaufen
          if  (Menu.bit4_1 ==0)
              { // Kalibrierung aus dem EEPROM nehmen 
	      		divider = RAM_Data.TouchScreenCalibrating.Divider;
   	      		An      = RAM_Data.TouchScreenCalibrating.An;
   	      		Bn      = RAM_Data.TouchScreenCalibrating.Bn;
   	      		Cn      = RAM_Data.TouchScreenCalibrating.Cn;
          		Dn      = RAM_Data.TouchScreenCalibrating.Dn;
          		En      = RAM_Data.TouchScreenCalibrating.En;
          		Fn      = RAM_Data.TouchScreenCalibrating.Fn;
	      		Menu.Window =Haupt_Menu; // und zum Hauptmen
	    	  }
          else{Menu.Window =Kal_Funktion;} // Countdown abgebrochen, zum Kalibrierungs Start
        }
    else{Menu.Window =Kal_Funktion;} // zum Kal.Men
// ***************************************************************************
//                            Men Seiten
// ***************************************************************************
    uint8_t links_re=0;

	while(Menu.Window !=10) // Abbruch mit 10
	     {					  
	       // bei jedem Menseiten Wechsel ausfhren ...
		   color_set(RAM_Data.Farbe.Grund); // Farbeinstellungen fr Schwarz oder Weissen Bildschirm
           bg_color(Menu.Farbe.Grund);      // Bildschirm lschen
		   Menu.Tab =1;                     // Cursor TAB auf Mitte < Men > Leiste
           
		   switch(Menu.Window)
	             { 
				   case Kal_Funktion: // ***************************
		                              // Touch -Screen -Kalibrierung
				                      // ***************************

					    // Function Calibrate Touch Screen Touch at Point + on Screen 3 Point(3 step) for Caribrate
						Menu.bit2_1 =0;

						plot_mark(17,32,24,25,Rot2);         // Plot Signe + for Position Calibrate Touch Point1
                        print_Str(" < TouchScreen Kalibrierung > ",2,0, 20,Menu.Farbe.TextGruen ,no_bg);
                        print_Str("       Schritt 1 von 3        ",2,0, 50,Menu.Farbe.TextGruen, no_bg);
                        print_Str("  Ber}hre das '+' Zeichen so  ",2,0,200,Menu.Farbe.Text, no_bg);
                        print_Str("     genau wie m|glich!       ",2,0,220,Menu.Farbe.Text, no_bg);

                        while(status_touch()) {;} // Wait until not Touch screen ,
                        while(Menu.bit2_1 != 3)	// Number Mark Point Calibrate = 3 Point 
	                         {
		                       if  (status_touch())    	// return (1) if touch screen is detected.
		                           {
			                         for (uint8_t n=0;n<50;n++)
			                             {
				                           tcs_read(); // Read portrait(ADC X,Y) by touch value from ADS7846 and update dif_adc_X & dif_adc_Y
				                           buf_adc_X[n] = dif_adc_X; // General buffer for averaging and filter touch screen adc read outs.
				                           buf_adc_Y[n] = dif_adc_Y; // General buffer for averaging and filter touch screen adc read outs.
			                             }
			                         ave_x_y(50);        // Take average out of 50 touch measurements, excluding max and min measurement.
			                         tcs_ave_X[Menu.bit2_1]=  ave_adc_X;
			                         tcs_ave_Y[Menu.bit2_1]=  ave_adc_Y;
			                         Menu.bit2_1++; // touch_cal_status;0=xy1,1=xy2,2=xy3,3=calibration success.0xff=calibrat. not performed.

			                         while(status_touch()) {;} // Waite until not Touch screen ,
			                         switch(Menu.bit2_1)	   // Select Caribrate Next Step 2 and 3
			                               {
					                         case 1: bg_color(Menu.Farbe.Grund);           // Clear Screen
						                             plot_mark(208,160,215,153,Rot2); 	   // Plot Signe + for Position Calibrate Touch Point2
                       	                             print_Str(" < TouchScreen Kalibrierung > ",2,0, 20,Menu.Farbe.TextGruen, no_bg);
                      	                             print_Str("       Schritt 2 von 3        ",2,0, 50,Menu.Farbe.TextGruen, no_bg);
                                                     print_Str("  Ber}hre das '+' Zeichen so  ",2,0,200,Menu.Farbe.Text, no_bg);
                     	                             print_Str("     genau wie m|glich!       ",2,0,220,Menu.Farbe.Text, no_bg);
						                     break;
					                         case 2:
						                             bg_color(Menu.Farbe.Grund);            // Clear Screen
						                             plot_mark(113,287,120,280,Rot2);       // Plot Signe + for Position Calibrate Touch Point3
						                             print_Str(" < TouchScreen Kalibrierung > ",2,0, 20,Gruen2, no_bg);
                      	                             print_Str("       Schritt 3 von 3        ",2,0, 50,Gruen2, no_bg);
                                                     print_Str("  Ber}hre das '+' Zeichen so  ",2,0,200,Weiss1, no_bg);
                     	                             print_Str("     genau wie m|glich!       ",2,0,220,Weiss1, no_bg);
						                     break;
			                               }
		                           }
		                       delay_ms(100);
	                         }
                        set_matrix(); // Calculate Coefficient for use find Position Address real on Display
						while(status_touch()) {;} // Wait TouchNotPressed
    	                bg_color(Menu.Farbe.Grund);
       		            print_Str("  Kalibrierung abgeschlossen! ",2,0,50,Menu.Farbe.TextGruen,no_bg);
						Menu.bit1_1 =1; // Merker das neue Kalib.Daten gelesen wurden
			            delay_ms(400);
			            Menu.Window =Kal_Menu; // zum Kalibrierungs Men
 		           break;
		           case Kal_Menu: // **************************
		                          // Kalibrierungs Men 
				                  // ***************************
                        bg_color(Menu.Farbe.Grund);
			            leiste_btn(); // Men Leiste erstellen
						print_Str(" Die Kalibrierungsdaten werden beim  ",1,9,100,Menu.Farbe.TextGruen, no_bg);
						print_Str(" verlassen zum Hauptmen} gespeichert!",1,9,110,Menu.Farbe.TextGruen, no_bg);
			            print_Str("Teste die Kalibrierung im Zeichenfeld",1,9,140,Menu.Farbe.Text, no_bg);
   			            Rectan(8,145,233,311,1,Menu.Farbe.Text,0);
                        
  	                    while(Menu.Window ==Kal_Menu)
		   	                 {
                          	   // --- Taster Abfragen ---
						 	   if  ( get_key_short( 1<<ESC_TASTER))   {tab_blink_tog(1,4); Menu.Window =Kal_Funktion; break;} // Kalibrierung starten
                         	   if  ( get_key_short( 1<<ENTER_TASTER)) {tab_blink_tog(1,4); Menu.Window =Haupt_Menu;} // zum Hauptmen
						 	   
				        	   // TouchFeld Abfragen, Rckgabewert: X,Y
							   X=-9; Y=-9;
				        	   if  (status_touch() )
						    	   {
							  	     get_point(20);
	
  				              	  	 if  (X>0 && X<240 && Y>0 && Y<320)
							      	     { // --- Zeichenfeld ---
				                    	   if  (Y<311 && Y>145 && X<233 && X>8)
		                                       {
			                              	     plot_dot(X,  Y,  Menu.Farbe.Text);
		                                  		 plot_dot(X-1,Y,  Menu.Farbe.Text);
		                                  		 plot_dot(X+1,Y,  Menu.Farbe.Text);
		     	                          		 plot_dot(X,  Y+1,Menu.Farbe.Text);
		     	                          		 plot_dot(X,  Y-1,Menu.Farbe.Text);
		       	                        	   };
                                    	   if  (Y<22 && (X<81 || X>160))
            	                        	   { // --- Menleiste ---
								          	     tab_blink(0);
				                          	     if  (X<81) {tab_blink_tog(1,4); Menu.Window=Kal_Funktion; break;} // links  < Touch Kalibrierung neu starten
								 	      	     else       {tab_blink_tog(1,4); Menu.Window=Haupt_Menu;} // rechts > zum Hauptmen
                                        	   }
				                  	     }
                                   }
					    	   // --- Kalibrierungsdaten im EEPROM speichern ---
				        	   if  (Menu.Window==Haupt_Menu && Menu.bit1_1)
						     	   { 
								     RAM_Data.TouchScreenCalibrating.Saved =1;
   	  	 			                 RAM_Data.TouchScreenCalibrating.Divider = divider;
   	  	 			                 RAM_Data.TouchScreenCalibrating.An = An;
   	  	 			                 RAM_Data.TouchScreenCalibrating.Bn = Bn;
   	  	 			                 RAM_Data.TouchScreenCalibrating.Cn = Cn;
      	 			                 RAM_Data.TouchScreenCalibrating.Dn = Dn;
      	 			                 RAM_Data.TouchScreenCalibrating.En = En;
      	 			               	 RAM_Data.TouchScreenCalibrating.Fn = Fn;
     
									 cli(); // interrupts deaktivieren
                                     eeprom_write_block(&RAM_Data.TouchScreenCalibrating,&EEP_Data.TouchScreenCalibrating,sizeof(RAM_Data.TouchScreenCalibrating));
                                     sei(); // Interrupts einschalten
                            	   }
                             } // while(Menu.Window ==Kal_Menu)
		           break;
		      	   case Haupt_Menu:          //      **************************************** * AnzTyp 0  : 9 DigitalFelder
		                                     //      *               Haupt Men             * * AnzTyp 1  : 4 DigitalFelder
				        update.small_clock=1;//      **************************************** * AnzTyp 2  : 1 Digital Feld
                        update.big_clock  =1;//       TouchKal(0)   < MEN(1)  >    Pumpen(2) * AnzTyp 3-6: Tag,Woche,Monat,Jahr Chart/Liste
				        leiste_btn();        //  25->+---+----+----+ +--+---+ +----+ +--+ *  AnzTyp 7  : Digital Uhr
			            ausgabe_fld(0);      //      |( 3)|( 4)|( 5)| |(3)|(4)| |     | |(3)| *  AnzTyp 8  : Analog Uhr
                        auswahl_btn(0,12);   //      |( 6)|( 7)|( 8)| +---+---+ | (3) | +---+ *  AnzTyp 9  : Videokanal (optional)  
				        eingabe_fld(0);      //      |( 9)|(10)|(11)| |(5)|(6)| |     | |(4)| 
				        auswahl_btn(0,13);   //      ^2   ^81  ^161   ^2  ^121  ^2      ^2    - bit6_1  : ListZelle(Listen)
				        auswahl_btn(0,14);   // 154->+----+----+--+-+-+---+---+++-----+-+---+ - bit16_1 : Min(Chart), Seiten(Liste)
				        auswahl_btn(0,15);   //      |<SenTyp(12)>|  "lschen" |<SenNum(13)>| - bit16_2 : Max(Chart)                
				        auswahl_btn(0,16);   // 187->+------------+------------+------------+ 
				        relais_btn();        //      |<AnzTyp(14)>|<AnzOp1(15)>|<AnzOp2(16)>| - SenTyp  : SensorTyp  0-12
				        info_fld(0);         // 220->+------------+------------+------------+ - SenNum  : SensorNum  0-15
				        uhr_fld(0);          //      |        RelaisAnzeige & Btn(17)       | - AnzTyp  : AnzeigeTyp 0- 9
				                             // 283->+------------------+-------------------+ - AnzOp1  : " Option 1 0-15
			           	                     //      |  Info Feld(18)   |   Uhr Feld(19)    | - AnzOp2  : " Option 2 0-15
			                                 // 317->+------------------+-------------------+ - AnzOp3  : Skala Nullpunkt(nur Chart) 0-15
			                                 //       ^2          ^81   ^121    ^161      237^
                         
					    while(Menu.Window ==Haupt_Menu)
			                 { 
							   links_re=0;
							   // --- Gehuse Taster abfragen ---
	                 		   if  ( get_key_short( 1<<LEFT_TASTER)) { taster_tab(left);}
                               else{ if  ( get_key_short( 1<<UP_TASTER)) { taster_tab(up);}
								     else{ if  ( get_key_short( 1<<RIGHT_TASTER)) { taster_tab(right);}
                                           else{ if  ( get_key_short( 1<<DOWN_TASTER)) { taster_tab(down);}
						                         else{ if  ( get_key_short( 1<<ESC_TASTER)) { links_re =1;} // links gedrckt
                                                       else{ if  ( get_key_short( 1<<ENTER_TASTER)) { links_re =2;} // rechts gedrckt
                                                           }
                                                     }
                                               }
                                         }
                                   }
							   if  (links_re) // ktion?
								   { tab_blink(0);
								     if  ( Menu.Tab >2 && Menu.Tab <17)
									     { if  ( Menu.Tab <12) 
									           { if  ( RAM_Data.AnzTyp <3 || (RAM_Data.AnzTyp <7 && RAM_Data.SenTyp <10 && Menu.Tab <5))
											         { ausgabe_fld(1);} // Digital Feld gedrckt
                                               }
                                           else{ auswahl_btn(links_re,Menu.Tab);} // Auswahl btn gedrckt
                                         }
                                     else{ switch(Menu.Tab) // anderer Btn...
									             { case  0: if  (links_re==2) 
												                {Menu.Window =Kal_Menu;}   break; // zum Kalibrierungs Men
                                                   case  1: if  (links_re==1)
												                {Menu.Window=Kal_Menu;}
															else{Menu.Window=Pumpen_Menu;} break; // ESC zum KalMen, ENTER zum PumpenMen
												   case  2: if  (links_re==2)
													            {Menu.Window=Pumpen_Menu;} break; // zum Pumpen Men
												   case 17: Menu.Window =Relais_Menu;      break; // zum Relais Men
							                       case 18: Menu.Window =Info_Menu;        break; // zum Info Men
							                       case 19: Menu.Window =Kalender_Menu;    break; // zum Kalender Men
                                                 }
                                         }
                                     tab_blink_tog(1,4);
                                   } // Ende Taster Aktion

                               // --- TouchFeld abfragen ---
				               X=-9; Y=-9; links_re=0;
						       if  (status_touch())
						           { tab_blink(0);
									 get_point(20); // Rckgabewert: X, Y
                                     if  (Y>0 && Y<320 && X>0 && X<240)
							             { if  (Y<25)
									           { // Menleiste
				                                 if  (X<81 || X>160)
										             { if  (X<81) {Menu.Tab=0; Menu.Window =Kal_Menu;}    // links  < Kalibrierung
				                                       else       {Menu.Tab=2; Menu.Window =Pumpen_Menu;} // rechts < Pumpen Men
                                                     };
                                               }
                                           else{ if  (Y<154)
							                         { // Ausgabe Feld
								                       switch(RAM_Data.AnzTyp)
 								                             { case 0: // 9 Ausgabe Felder
								                                       if  (X<98)                            // Spalte 1;
		                                                                   { if  (Y<66)        {links_re=1; Menu.Tab=3;} // Feld 1
		                                                                     else{ if  (Y<109) {links_re=1; Menu.Tab=6;} // Feld 4
		                                                                           else        {links_re=1; Menu.Tab=9;} // Feld 7
                                                                                 }
                                                                           }
		                                                               else{ if  (X<161)                            // Spalte 2;
	                                                                             { if  (Y<66)        {links_re=1; Menu.Tab= 4;} // Feld 2
		                                                                           else{ if  (Y<109) {links_re=1; Menu.Tab= 7;} // Feld 5
		                                                                                 else        {links_re=1; Menu.Tab=10;} // Feld 8
		                                                                               }
		                                                                         }                                   // Spalte 3;
		                                                                     else{ if  (Y<66)        {links_re=1; Menu.Tab = 5;} // Feld 3
		                                                                           else{ if  (Y<109) {links_re=1; Menu.Tab = 8;} // Feld 6
		                                                                                 else        {links_re=1; Menu.Tab =11;} // Feld 9
		                                                                               }
                                                                                 }
                                                                           }
                                                               break;
											                   case 1: // 4 Ausgabe Felder
							                                           if  (X<121)                    // Spalte 1;
		                                                                   { if  (Y<90) {links_re=1; Menu.Tab=3;} // Feld 1
		                                                                     else       {links_re=1; Menu.Tab=5;} // Feld 3
                                                                           }                          // Spalte 2;
		                                                               else{ if  (Y<90) {links_re=1; Menu.Tab=4;} // Feld 2
  		                                                                     else       {links_re=1; Menu.Tab=6;} // Feld 4
		                                                                   }
                                                               break;
											                   case 2: // 1 Ausgabe Feld
							                                           links_re=1; Menu.Tab=3;
                                                               break;
															   default:if  (RAM_Data.AnzTyp <7 && RAM_Data.SenTyp <10)
									                                       { // Ausgabe Chart
											                                 if  (X<30)
														                         { if  (Y<88)
													  		     	                   {links_re=1; Menu.Tab=3;}
																	               else{links_re=1; Menu.Tab=4;} // skala nullpunkt +/- Btns
																                 }
                                                                           }
                                                               break;
                                                             }
                                                       if  (links_re)
													       { tab_blink_tog(1,4);
													 	     ausgabe_fld(1);
                                                           }
                                                     } 
                                                 else{ if  (Y<185)
												           {
											  			     if  ((X<81 || X>160) && RAM_Data.AnzTyp <7) // SensorTyp & Nr.Btn, gibts bei D&A-Clock, Video nicht
				                                                 { if  (X<81) // SensorTyp Btn
							                                           { if  (X<41) {links_re =1;} else{links_re=2;}
														 		         Menu.Tab=12;
                                                                       }
                                                                   else{ // SensorNr.Btn
													                     if  (X<200) {links_re=1;} else{links_re=2;}
                                                                         Menu.Tab=13;
                                                                       }
                                                                 }
                                                           }
				                                       else{ if  (Y<218)
												                 { if  (X<81)
														 	           { // AnzeigeTyp Btn
															             if  (X<41) {links_re=1;} else{links_re=2;}
																         Menu.Tab=14;
																       }
                                                                   else{ if  (X<161)
																 		     { // Option 1 Btn
																		       if  (X<121) {links_re=1;} else{links_re=2;}
																			   Menu.Tab=15;
																		     }
                                                                         else{ // Option 2 Btn
																		       if  (X<200) {links_re=1;} else{links_re=2;}
							                                                   Menu.Tab=16;
                                                                             }
                                                                       }
                                                                 }
 				   	                                         else{ if  (Y<282)
				                                                       { // groer Relais Btn
									                                     Menu.Tab=17;
							                                             tab_blink_tog(1,4);
					                                                     Menu.Window =Relais_Menu; // zum Relais Men
				                                                       }
                                                                   else{ if  (X<120)
				                                                             { // Info Feld
																	           Menu.Tab=18;
                                                                               tab_blink_tog(1,4);
					                                                           Menu.Window =Info_Menu; // zum Info Men
                                                                             }
				                                                         else{ // Uhr/ Kalender
								                                               Menu.Tab=19;
                                                                               tab_blink_tog(1,4);
					                                                           Menu.Window =Kalender_Menu; // zum Uhr Men
                                                                             }
                                                                       }
				                                                 }
                                                           }
                                                       if  (links_re)
														   { tab_blink_tog(1,4);
								                             auswahl_btn(links_re, Menu.Tab);
                                                           }
                                                     }
                                               }
                                         }
                                   }
					         }; // while (Hauptmen) ENDE
  		           break;
			       case Pumpen_Menu:          //      *********************************************
			                                  //      *                Pumpen Men                *
						Menu.bit4_1 =0;       //      *********************************************
						Menu.bit2_1 =0;       //       Hauptmen(0)   < PUMPEN(1) >  Einstellung(2)
				        Menu.bit2_2 =0;	      //  25->+--------+----------------------------------+
				        Menu.bit4_2 =0;       //      |Farbe(2)| Mo | Di | Mi | Do | Fr | Sa | So |   - bit4_1 : Farbauswahl 0-15
				        leiste_btn();         //  48->+--------+----+----+----+----+----+----+----+   - bit2_1 : Zelle aktiv 0, 1Wert,2Label
				        dosier_tabelle(0);    //      |MagV( 3)|( 4)|( 5)|( 6)|( 7)|( 8)|( 9)|(10)|   - bit2_2 : B-Programm  0- 3
				        auswahl_btn(0,75);    //  67->+--------+----+----+----+----+----+----+----+   - bit4_2 : B-Woche     0-15
				        cursor_btn(0);        //      |DosP(11)|(12)|(13)|(14)|(15)|(16)|(17)|(18)|
				        auswahl_btn(0,77);    //  86->+--------+----+----+----+----+----+----+----+
				        eingabe_fld();        //      |DosP(19)|(20)|(21)|(22)|(23)|(24)|(25)|(26)|
				        clear_btn(0);         // 105->+--------+----+----+----+----+----+----+----+
				        enter_btn(0);         //      |DosP(27)|(28)|(29)|(30)|(31)|(32)|(33)|(34)|
			  	                              // 124->+--------+----+----+----+----+----+----+----+
			                                  //      |DosP(35)|(36)|(37)|(38)|(39)|(40)|(41)|(42)|
					 		                  // 143->+--------+----+----+----+----+----+----+----+
						                      //      |DosP(43)|(44)|(45)|(46)|(47)|(48)|(49)|(50)|
									  	      // 162->+--------+----+----+----+----+----+----+----+
										      //      |DosP(51)|(52)|(53)|(54)|(55)|(56)|(57)|(58)|
										      // 181->+--------+----+----+----+----+----+----+----+
										      //      |DosP(59)|(60)|(61)|(62)|(63)|(64)|(65)|(66)|
										      // 200->+--------+----+----+----+----+----+----+----+
				                    	      //      |DosP(67)|(68)|(69)|(70)|(71)|(72)|(73)|(74)|
										      // 219->+--------+----+----+----+----+----+----+----+
										      //      ^2       ^62  ^87  ^112 ^137 ^162 ^187 ^212 ^237
				                    	      // 221->+--------------+-------------+--------------+
                                    	      //      |<Programm(75)>|    UP(76)   |<BewWoche(77)>|
										      // 254->+--------------+-------------+--------------+
										      //      |   LEFT(78)   |    "005"    |   RIGHT(79)  |
										      // 286->+--------------+-------------+--------------+
										      //      |  Clear (80)  |   DOWN(81)  |   ENTER(82)  |
										      // 317->+--------------+-------------+--------------+
        	                                  //      ^2             ^81           ^161           ^237
 
						while(Menu.Window==Pumpen_Menu)
						     {
							   links_re =0;
							   // --- Gehuse Taster Abfragen ---
	                           if  ( get_key_short( 1<<LEFT_TASTER))  {taster_tab(left);}
	                           else{ if  ( get_key_short( 1<<UP_TASTER))    {taster_tab(up);}
	                                 else{ if  ( get_key_short( 1<<RIGHT_TASTER)) {taster_tab(right);}
	                                       else{ if  ( get_key_short( 1<<DOWN_TASTER))  {taster_tab(down);}
                                                 else{ if  ( get_key_short( 1<<ESC_TASTER))   {links_re =1;}
							                           else{ if  ( get_key_short( 1<<ENTER_TASTER)) {links_re =2;}
                                                           }
                                                     }
                                               }
                                         }
                                   }
                               if  (links_re)
							       { tab_blink(0);
								     if  (Menu.Tab==2 || (Menu.Tab>1 && Menu.Tab<75 && !Menu.bit2_1))
								         { // Dosier-Tabelle
										   dosier_tabelle(links_re);
										   links_re =0;
										 }
							         else{
										   switch(Menu.Tab)
								                 {
									        	   case  0: if  (links_re==2)
												                {Menu.Window=Haupt_Menu;}break; // ENTER Taste auf Tab0 - zum Hauptmen
												   case  1: if  (links_re==1)
												                {Menu.Window=Haupt_Menu;}break; // ESC Taste auf Tab1 - zum Hauptmen
							                       case 75: auswahl_btn(links_re, 75);   break; // Programm Btn
												   case 76: cursor_btn(1);               break; // Up
											 	   case 77: auswahl_btn(links_re, 77);   break; // Wochen Auwahl Btn
												   case 78: cursor_btn(2);               break; // Left
												   case 79: cursor_btn(3);               break; // Right
											  	   case 80: clear_btn(1);                break; // Zelle/Woche Clr
												   case 81: cursor_btn(4);               break; // Down
												   case 82: enter_btn(1);                break; // Save Btn
	                                             }
	                                     }
                                     tab_blink_tog(1,4);
	                               }

	   				    	   // --- TouchFeld Abfragen; Rckgabe: X,Y ---
					    	   X=-9; Y=-9; links_re=0;
							   if  (status_touch() )
							       {
								     get_point(20);
                                     if  (Y>0 && Y<320 && X>0 && X<240)
							             { if  (Y<25)
									           { // Menleiste
				                                  if  (X<81)
										              { tab_blink(0);
											            Menu.Tab =0;
												        Menu.Window=Haupt_Menu; // links  < zum Hauptmen
                                                      };
                                               }
                                           else{ if  (Y<221)
										             { 
													   if  ((X<63 && Y<48) || !Menu.bit2_1)
													       { // Tabelle anklicken
 											                 tab_blink(0);
											                 if  (X<63)
												                 {
													               if  (Y<48)
													                   { // Farbauswahl Btn
															             if  (X<24) {links_re =1;} else{links_re =2;}
															             Menu.Tab=2;
													  	               } 
													               else{ // Zeilenbeschriftung
 													                     links_re =1;
															             Menu.Tab =((Y-48)/19)*8+3;
                                                                       }
                                                                   dosier_tabelle(links_re);
													             }
											                 else{ // Tabellenzelle gedrckt
											                       if  (Y>47)
													                   { Menu.Tab =4 +((X-63)/25) + (((Y-48)/19)*8);
														                 dosier_tabelle(1);
                                                                       }
	                                                             }
	                                                       }
                                                     }
	                                             else{ if  (Y<254)
								                           { // 1. Btn Zeile
									                         tab_blink(0);
										                     if  (X<81) // "Programm" Btn
													             { if  (X<41) {links_re=1;}else{links_re=2;}
													               Menu.Tab=75; auswahl_btn(links_re,75);
													             } 
										                     else{ if  (X<161) // Cursor UP
														               {Menu.Tab=76; cursor_btn(1);}
	  			        	                                       else{ // Wochen Auswahl Btn
													                     if  (X<200) {links_re=1;}else{links_re=2;}
													                     Menu.Tab=77; auswahl_btn(links_re,77);
												  	                   }
											                     }
									                         tab_blink_tog(1,4);
	 				      	 	                           }
	      			                                   else{ if  (Y<286 && (X<81 || X>160))
					        	                                 { // 2. Btn Zeile
								                                   tab_blink(0);
								                                   if  (X<81) {Menu.Tab=78; cursor_btn(2);} // Cursor LEFT
										                           else       {Menu.Tab=79; cursor_btn(3);} // Cursor RIGHT
										                           tab_blink_tog(1,4);
	                                                             }
	                                                         else{ // 3. Btn Zeile
									                               tab_blink(0);
	                                                               if  (X<81)
																       {Menu.Tab=80; clear_btn(1);}   // Zelle/ Woche clear
											                       else{ if  (X<161) {Menu.Tab =81; cursor_btn(4);} // Cursor DOWN
			                                                             else        {Menu.Tab =82; enter_btn(1);}  // Zelle/Zeilenfarbe/ Programm set&save
                                                                       }
			                                                     }
	                                                         tab_blink_tog(1,4);
					       	                               }
					    	                         }
					                           }
	                                     }
                                   }
                             }
                   break;
		           case Relais_Menu:        //      ****************************************
		                Menu.bit1_4 =0;     //      *             Relais Men              *
				        Menu.bit6_1 =0;     //      ****************************************
			            Menu.bit2_1 =0;     //       Hauptmen(0) < Aktion(1)>  RelaListe(2)   - bit1_4 ; Schaltfeld ausgewhlt 0,1
				  		Menu.bit4_1 =0;     //  25->+------------+------------+------------+
		                Menu.bit4_2 =0;     //      |< Aktor(3) >|< Modus(4) >|< Delay(5) >|   - bit6_1 : AktorWahl     0-31
					    Menu.bit4_3 =0;     //  58->+------------+------------+------------+   - bit2_1 : AktorModus    0- 2
					    Menu.bit2_2 =0;     //      |  Ein1( 6)  |  Ein2( 7)  |  Ein3( 8)  |   - bit4_1 : Delay/B-Woche 0-15
					    Menu.bit1_1 =0;     // 106->+------------+------------+------------+   - bit4_2 : SensorTyp     0-12
					    Menu.bit1_2 =0;     //      |  Aus1( 9)  |  Aus2(10)  |  Aus3(11)  |   - bit4_3 : SensorNum     0-15
						Menu.bit1_3 =0;     // 154->+------------+------------+------------+   - bit2_2 : UndOder       0- 3
						Menu.bit2_3 =0;     //      |< Typ (12) >|< Num (13) >|< & / (14) >|   - bit1_1 : AktorLabel    0, 1
						leiste_btn();       // 187->+------------+-----+------+------------+   - bit1_2 : SensorLabel   0, 1
						auswahl_btn(0, 3);  //      |< AktorLabel(15) >|< SensorLabel(16) >|   - bit1_3 : Minus         0, 1
			   	  	    auswahl_btn(0, 4);  // 220->+------------+-----+------+------------+   - bit2_3 : = < >         0- 2
						auswahl_btn(0, 5);  //      |< Minus(17)>|   UP(18)   |<  < >(19) >|   
						switch_fld(0);      // 253->+------------+------------+------------+
						auswahl_btn(0,12);  //      |  LEFT(20)  | "eingabe"  |  RIGHT(21) |
						auswahl_btn(0,13);  // 286->+------------+------------+------------+
					  	auswahl_btn(0,14);  //      |  CLEAR(22) |  DOWN(23)  |  ENTER(24) |
						auswahl_btn(0,15);  //      +------------+------------+------------+
                        auswahl_btn(0,16);  //      ^2           ^81          ^161       237^
						auswahl_btn(0,17); cursor_btn(0); auswahl_btn(0,19); eingabe_fld(0); clear_btn(0); enter_btn(0);

					  	while(Menu.Window==Relais_Menu)
					         { 
							   links_re =0;
							   // --- Gehuse Taster Abfragen ---
		                       if  ( get_key_short( 1<<LEFT_TASTER)) {taster_tab(left);}
		                       else{ if  ( get_key_short( 1<<UP_TASTER)) {taster_tab(up);}
		                             else{ if  ( get_key_short( 1<<RIGHT_TASTER)) {taster_tab(right);}
									       else{ if  ( get_key_short( 1 <<DOWN_TASTER)) {taster_tab(down);}
							                     else{ if  ( get_key_short( 1<<ENTER_TASTER)) {links_re=2;}
							                           else{ if  ( get_key_short( 1<<ESC_TASTER))   {links_re=1;}
													       }
                                                     }
                                               }
                                         }
                                   }
							   if  (links_re)
								   { tab_blink(0);
								     // Ein/Aus Bedingungsfelder
									 if  (Menu.Tab>5 && Menu.Tab<12 && !Menu.bit4_1)
									     {switch_fld(1);}
								     else{ // Cursor Tasten
									       if  (Menu.Tab==18 || Menu.Tab==20 || Menu.Tab==21 || Menu.Tab==23)
									           {cursor_btn(1);}
									       else{
									             switch(Menu.Tab)
									                   {
										            	 case  0: if  (links_re==2)
														              {Menu.Window=Haupt_Menu;  }break; // zum Hauptmen
								                 	     case  1: if  (links_re==1)
														              {Menu.Window=Haupt_Menu;  }       // "   "
														          else{Menu.Window=Relais_Liste;}break; // zur RelaisListe
														 case  2: if  (links_re==2)
														              {Menu.Window=Relais_Liste;}break; // zur RelaisListe
														 case 22: clear_btn(1);                  break; // Clear
														 case 24: enter_btn(1);                  break; // Enter
														 default: if  (Menu.Tab>2 && Menu.Tab<20)
														              {auswahl_btn(links_re,Menu.Tab);} // Auswahl Btn
                                                         break;
		                                               }
		                                       }
								         }
                                     tab_blink_tog(1,4);
		                           }

		   				       // --- TouchFeld Abfragen; Rckgabe: X,Y ---
						       X=-9; Y=-9; links_re=0;
							   if  (status_touch() )
							       {
							  	     get_point(20);
                                     if  (Y>0 && Y<320 && X>0 && X<240)
								         {
		                    	           if  (Y<25)
										       { // Menleiste
											     if  (X<81 || X>160)
						       	                     {
								  			           tab_blink(0);
						        	                   if  (X<81) {Menu.Tab=0; Menu.Window=Haupt_Menu;}   // links  < zum Hauptmen
												       else       {Menu.Tab=2; Menu.Window=Relais_Liste;} // rechts > zur RelaisListe
											           tab_blink_tog(1,4);
						   	         	             };
                                               }
		 				       	           else{
										         if  (Y<58)
									                 { // 1. Btn Zeile
										               tab_blink(0);
											           if  (X<81)
												           { if  (X<41) {links_re=1;} else{links_re=2;}
													         Menu.Tab=3; auswahl_btn(links_re, 3); // Aktor Btn
                                                           }
						    	                       else{ if  (X<161)
												                 { if  (X<121) {links_re=1;} else{links_re=2;}
														           Menu.Tab=4; auswahl_btn(links_re, 4); // Modus Btn
                                                                 }
							     	                         else{ if  (X<200) {links_re=1;} else{links_re=2;}
													               Menu.Tab=5; auswahl_btn(links_re, 5); // PowerDelay
                                                                 }
		                                                   }
		                                               tab_blink_tog(1,4);
		                                             }
                                                 else{
												       if  (Y<154 && !Menu.bit4_1)
						        	                       { // Ein/Ausschalt Bedingungsfelder
											                 tab_blink(0);
									                         if  (Y<106)
											                     { // grne Einschaltfelder
												                   if  (X<81)        {Menu.Tab =6;} // 1.Feld
			                                                       else{ if  (X<161) {Menu.Tab =7;} // 2.Feld
				                                                         else        {Menu.Tab =8;} // 3.Feld
				                                                       }
		                                                         }
		                                                     else{ // rote Ausschaltfelder
		      	                                                   if  (X<81)        {Menu.Tab = 9;} // 1.Feld
				                                                   else{ if  (X<161) {Menu.Tab =10;} // 2.Feld
				                                                         else        {Menu.Tab =11;} // 3.Feld
		                                                               }
		                                                         }
						                                     switch_fld(1);
							     	                         tab_blink_tog(1,4);
		                                                   }
						       	                       else{
													         if  (Y<187)
						        	                             { // 2.Btn Zeile
										                           tab_blink(0);
							                                       if  (X<81)
												                       { if  (X<41) {links_re=1;} else{links_re=2;}
													                     Menu.Tab=12; auswahl_btn(links_re, 12); // SenTyp
                                                                       }
											                       else{ if  (X<161)
												                             { if  (X<121) {links_re=1;} else{links_re=2;}
														                       Menu.Tab=13; auswahl_btn(links_re,13); // SenNum
																			 }
		 									                             else{Menu.Tab=14; auswahl_btn(links_re,14);} // Und-Oder
		                                                               }
						        	                               tab_blink_tog(1,4);
		                                                         }
						    	                             else{ 
															       if  (Y<220)
																       { // 3.Btn Zeile
																	     tab_blink(0);
																		 if  (X<118)
						       	                                             {
									                                           if  (X< 58) {links_re=1;}else{links_re=2;}
																			   Menu.Tab=15; // Aktor Label
																			 }
				                                                         else{ if  (X<178) {links_re=1;}else{links_re=2;}
																		       Menu.Tab=16; // Cursor RIGHT
											                                 }
																	     auswahl_btn(links_re,Menu.Tab);
											                             tab_blink_tog(1,4);
		                                                               }
																   else{ 
																         if  (Y<253)
									                                         { // 4.Btn Zeile
										                                       tab_blink(0);
		                                                                       if  (X<81)
																			       {Menu.Tab=17; auswahl_btn(links_re,17);} // MINUS
										                                       else{ if  (X<161)
																			             {Menu.Tab=18; cursor_btn(1);}     // UP
					                                                                 else{ if  (X<200) {links_re=1;}else{links_re=2;}
																					       Menu.Tab=19; auswahl_btn(links_re,19); // (<>)
					                                                                     }
                                                                                    }
		                                                                       tab_blink_tog(1,4);
		                                                                     }
		                                                                 else{
																		       if  (Y<286)
																			       { // 5.Btn Zeile
																				     if  (X<81 || X>160)
																					     {
																						   tab_blink(0);
																					       if  (X<81)
																					           {Menu.Tab=20;} // LEFT
                                                                                           else{Menu.Tab=21;} // RIGHT
																						   cursor_btn(Menu.Tab-18);
																					       tab_blink_tog(1,4);
                                                                                         }
																				   }
		                                                                       else{ // 6.Btn Zeile
										                                             tab_blink(0);
											                                         if  (X<81)
																					     {Menu.Tab=22; clear_btn(1);} // CLEAR
											                                         else{ if  (X<161)
																					           {Menu.Tab=23; cursor_btn(4);} // DOWN
											                                               else{Menu.Tab=24; enter_btn(1);}  // ENTER
										                                                 }
		                                                                             tab_blink_tog(1,4);
		                                                                           }
                                                                             }
                                                                       }
                                                                 }
                                                           }
                                                     }
                                               }
		                                 }
						           }
		                     }
				   break;
		           case Relais_Liste: // ******************************
		                              // Relaismen bersicht
				                      // ******************************
			            leiste_btn(); // Men Leiste erstellen
		           break;
				   case Kalender_Menu:     //      **********************************************
		         	                       //      *               Kalender Men                *
					    Menu.bit1_1=0;     //      **********************************************
             	        Menu.bit1_2=0;     //      Hauptmen(0)      <  Zeit  >
				        Menu.bit4_1=0;     //  25->+----+----+----+----+----+----+----+----+----+
				        Menu.bit1_3=0;     //      |    | Mo | Di | Mi | Do | Fr | Sa | So |    |   - bit1_1  : Zelle aktiv. 0, 1
				        Menu.bit1_4=0;     //  48->|    +----+----+----+----+----+----+----+    |   - bit1_2  : jedes Jahr   0, 1
				        leiste_btn();      //      |    |( 4)|( 5)|( 6)|( 7)|( 8)|( 9)|(10)|    |   - bit4_1  : Farbauswahl  0-15
				        kalender(0);       //  67->|    +----+----+----+----+----+----+----+    |   - bit1_3  : Uhr stellen  0, 1
				        auswahl_btn(0,53); //      |    |(11)|(12)|(13)|(14)|(15)|(16)|(17)|    |   - bit1_4  : Dat stellen  0, 1
				      //  eingabe_fld2();    //  86->|    +----+----+----+----+----+----+----+    |
						auswahl_btn(0,54); //      |    |(18)|(19)|(20)|(21)|(22)|(23)|(24)|    |
				        auswahl_btn(0,55); // 205->| <- +----+----+----+----+----+----+----+ -> |
				        cursor_btn(0);     //      | (2)|(25)|(26)|(27)|(28)|(29)|(30)|(31)| (3)|
			  	        auswahl_btn(0,57); // 124->|    +----+----+----+----+----+----+----+    |
			            eingabe_fld();     //      |    |(32)|(33)|(34)|(35)|(36)|(37)|(38)|    |
		                clear_btn(0);      // 143->|    +----+----+----+----+----+----+----+    |
						enter_btn(0);      //      |    |(39)|(40)|(41)|(42)|(43)|(44)|(45)|    |
						                   // 162->|    +----+----+----+----+----+----+----+    |
										   //      |    |(46)|(47)|(48)|(49)|(50)|(51)|(52)|    |
						                   //      +----+----+----+----+----+----+----+----+----+
										   //      ^2   ^32  ^57  ^82  ^107 ^132 ^157 ^182 ^207 ^237
										   // 187->+--------------+--------------+--------------+
										   //      |< j.Jahr(53) >|  "eingabe2"  |< Farbe (54) >|
										   // 220->+--------------+--------------+--------------+
										   //      | 20:15Uhr(55) |    UP(56)    |17.05.2010(57)|
				                    	   // 253->+--------------+--------------+--------------+
                                    	   //      |   LEFT (58)  |   "eingabe"  |   RIGHT(59)  |
										   // 286->+--------------+--------------+--------------+
										   //      |  CLEAR (60)  |   DOWN (61)  |  ENTER (62)  |
								           // 317->+--------------+--------------+--------------+
        	                               //      ^2           78^           158^           237^
 
						while(Menu.Window==Kalender_Menu)
						     { 
							   links_re=0;
							   // --- Gehuse Taster Abfragen ---	
	                           if  ( get_key_short( 1<<LEFT_TASTER)) {taster_tab(left);}
	                           else{ if  ( get_key_short( 1<<UP_TASTER)) {taster_tab(up);}
	                                 else{ if  ( get_key_short( 1<<RIGHT_TASTER)) {taster_tab(right);}
	                                       else{ if  ( get_key_short( 1<<DOWN_TASTER)) {taster_tab(down);}
							                     else{ if  ( get_key_short( 1<<ENTER_TASTER)) {links_re=2;}
							                           else{ if  ( get_key_short( 1<<ESC_TASTER))   {links_re=1;}
													       }
                                                     }
                                               }
                                         }
                                   }
							   if  (links_re)
							       { tab_blink(0);
								     // Dosier-Tabelle gedrckt
								     if  (Menu.Tab>1 && Menu.Tab<53 && !Menu.bit1_1)
								         { dosier_tabelle(1);}
							         else{
										   switch(Menu.Tab)
								                 {
									        	   case  0: if  (links_re==2) {Menu.Window=Haupt_Menu;} break; // Haupt Men
												   case  1: if  (links_re==1) {Menu.Window=Haupt_Menu;} break; // "
							                 	   case 56: cursor_btn(1); break; // Up
											 	   case 58: cursor_btn(2); break; // Left
												   case 59: cursor_btn(3); break; // Right
											  	   case 60: clear_btn(1);  break; // Zelle/Woche Clr
												   case 61: cursor_btn(4); break; // Down
												   case 62: enter_btn(1);  break; // Zelle/Zeilenfarbe/Programm Set&Save
												   default: auswahl_btn(links_re, Menu.Tab); break;
	                                             }
	                                     }
                                     tab_blink_tog(1,4);
	                               }

	   				    	   // --- TouchFeld Abfragen; Rckgabe: X,Y ---
					    	   X=-9; Y=-9; links_re=0;
							   if  (status_touch() )
							       {
								     get_point(20);

	                    	         if  (Y>0 && Y<320 && X>0 && X<240)
								         {
								           if  (Y<25)
										       { // Menleiste
											     if  (X<81)
					       	                         { 
					        	                       tab_blink(0);
											           Menu.Tab =0;
													   Menu.Window=Haupt_Menu; // links  < zum Hauptmen
										               tab_blink_tog(1,4);
													 }
                                               }
                                           else{ if  (Y<187)
										             { // Kalender 
													   if  (!Menu.bit1_1)
										                   { 
 											                 tab_blink(0);
											                 if  (X<32 || X>206)
															     { // nchster/letzter Monat
																   if  (X<32) { Menu.Tab=2;} // Monat zurck blttern...
																   else       { Menu.Tab=3;} // Monat vor blttern
																 }
                                                             else{ // Kalender Zelle 
															       Menu.Tab = 4+((X-31)/25) + (((Y-48)/23)*7);
															     }
														     kalender(1);
                                                             tab_blink_tog(1,4);
                                                           }
                                                     }
                                                 else{ if  (Y<220)
													       { // 1.Btn Reihe
														     if  (X<82 || X>160)
																 {
																   tab_blink(0);
																   if  (X<82) {links_re=1; Menu.Tab=53;} // jedes Jahr
																   else       { Menu.Tab=54;
																                if  (X<200) {links_re=1;}else{links_re=2;}
																			  } // Farbauswahl
																   auswahl_btn(links_re,Menu.Tab);
																   tab_blink_tog(1,4);
															     }
                                                           }
													   else{ if  (Y<253)
															     { // 2.Btn Reihe 
																   tab_blink(0);
																   if  (X<82)
																       {Menu.Tab=55; auswahl_btn(1,55);} // Uhrzeit stellen
																   else{ if  (X<161)
																             {Menu.Tab=56; cursor_btn(1);} // UP
																         else{ 
																		       Menu.Tab=57;
																			   if  (X<200) {links_re=1;}else{links_re=2;}
																			   auswahl_btn(links_re,57);
                                                                             }
															           }
                                                                   tab_blink_tog(1,4);
															     }
                                                             else{ if  (Y<286)
												                       { // 3.Btn Reihe
																	     if  (X<82 || X>160)
																		     { tab_blink(0);
																			   if  (X<82) {Menu.Tab=58;}
																			   else       {Menu.Tab=59;}
																			   cursor_btn(Menu.Tab-56);
																			   tab_blink_tog(1,4);
                                                                             }
                                                                       }
                                                                   else{ // 4.Btn Reihe
																         tab_blink(0);
																         if  (X<81)
																		     {Menu.Tab=60; clear_btn(1);} // CLEAR
																		 else{ if  (X<161) {Menu.Tab=61; cursor_btn(4);} // DOWN
																		       else        {Menu.Tab=62; enter_btn(1);} // ENTER
                                                                             }
													                     tab_blink_tog(1,4);
                           									  	       }
						              					         }
                                                           }
	 				      	 	                     }
									           }
                                         }
					               };
	                         };
                   break;
		           case Info_Menu:    // ******************************
		                              // Info Men
				                      // ******************************
			  		    leiste_btn(); // Men Leiste erstellen
		 	       break;
	             }; // Switch Ende
         }; // Ende While (window !=10)
  }; // Ende main
//###########################################################################################################






